REM file: Sic16.inc v64.0a r5.9a - Symbolic Instruction Code Kit; include module.

REM $DYNAMIC
DEFINT A-Z

' subroutine declarations
DECLARE SUB Analyze.Program ()
DECLARE SUB Arith (V$, V1#, V2#)
DECLARE SUB Assign.End ()
DECLARE SUB Assignment1 (V$, V%)
DECLARE SUB Assignment2 (V$, V1%, V2%)
DECLARE SUB Assignment3 (V$, V1$)
DECLARE SUB Assignment4 (V$, V1$)
DECLARE SUB Concatenate (V$)
DECLARE SUB Check.Drive (V%, V#)
DECLARE SUB Count.Lines (V%)
DECLARE SUB Decrease.PSP ()
DECLARE SUB Display.Error ()
DECLARE SUB Debug.Command ()
DECLARE SUB End.Program ()
DECLARE SUB Enter.Equate ()
DECLARE SUB Enter.Program.Line ()
DECLARE SUB Equate (V#)
DECLARE SUB Execute.Command (V$)
DECLARE SUB Find.File (V$, V%)
DECLARE SUB Get.Token ()
DECLARE SUB Get.Token2 (V%)
DECLARE SUB Get.Token3 ()
DECLARE SUB Get.Token4 ()
DECLARE SUB Indent.Program (V%)
DECLARE SUB Key.Prompt ()
DECLARE SUB Kill.Program (V$)
DECLARE SUB List.Drives (V$, V%)
DECLARE SUB List.Files (V$, V%)
DECLARE SUB List.Help ()
DECLARE SUB List.Help.File ()
DECLARE SUB List.Program (V1%, V2%, V3%)
DECLARE SUB Load.Program (V$)
DECLARE SUB More.Prompt (V1$, V2$, V$)
DECLARE SUB New.Program ()
DECLARE SUB OS ()
DECLARE SUB Parse.Alphabetic1 (V#)
DECLARE SUB Parse.Alphabetic2 (V#)
DECLARE SUB Parse.Alphabetic3 (V#)
DECLARE SUB Parse.Numeric (V#)
DECLARE SUB Parse.Quoted ()
DECLARE SUB Parse1 (V#)
DECLARE SUB Parse2 (V#)
DECLARE SUB Parse3 (V#)
DECLARE SUB Parse4 (V#)
DECLARE SUB Parse5 (V#)
DECLARE SUB Parse6 (V#)
DECLARE SUB Parse7 (V#)
DECLARE SUB Parse8 (V#)
DECLARE SUB Parse9 (V#)
DECLARE SUB Prepare.Program ()
DECLARE SUB Quit.Program ()
DECLARE SUB Read.Config (V%)
DECLARE SUB Read.Data.Element (V%)
DECLARE SUB Read.Program ()
DECLARE SUB Release.Time (V%)
DECLARE SUB Renumber.Program (V1%, V2%)
DECLARE SUB Run.Program (V%)
DECLARE SUB Save.Current ()
DECLARE SUB Save.Program (V$)
DECLARE SUB Save.Screen2 (V%)
DECLARE SUB Search.Program ()
DECLARE SUB Stop.Program ()
DECLARE SUB Store.Program ()
DECLARE SUB Whatis.Command (V$)

' added 08/10/2021
DECLARE SUB Read.Rows (V%)
DECLARE SUB ClearStatusLine ()
DECLARE SUB StatusLine ()

' function declarations
DECLARE FUNCTION Ambiguate$ (V$)
DECLARE FUNCTION BreakIS ()
DECLARE FUNCTION ClearBreak ()
DECLARE FUNCTION ClearBuffer ()
DECLARE FUNCTION FormatString$ (s#)
DECLARE FUNCTION FreeFileNumber ()
DECLARE FUNCTION KeyboardChar$ ()
DECLARE FUNCTION KeyboardLine$ ()
DECLARE FUNCTION KeyboardLine2$ ()
DECLARE FUNCTION KeyIS ()
DECLARE FUNCTION TempName$ ()
DECLARE FUNCTION Timeit! ()

DECLARE FUNCTION STRIM$ (V$)
DECLARE FUNCTION TTRIM$ (V$, V%)
DECLARE FUNCTION XTRIM$ (V$, V%)

' boolean constants
CONST Dfalse = 0#
CONST Dtrue = -1#
CONST False = 0
CONST True = -1

' color constants
CONST Black = 0
CONST Blue = 1
CONST Plain = 7
CONST Green = 10
CONST Cyan = 11
CONST Red = 12
CONST Magenta = 13
CONST Yellow = 14
CONST White = 15

' can be changed
CONST Max.Arrays = 128
CONST Max.Include.Recurse = 10
CONST Max.FN.Length = 1024
CONST Max.Functions = 26
CONST Max.History = 10
CONST Max.Nest.Gosubs = 128
CONST Max.Recurse = 16

' cannot be changed
CONST ErrorList = "sic86a.dat"
CONST MaxInt = 32766
CONST MaxFiles = 255
CONST MaxCommands = 24
CONST MaxStatements = 151

' should not be changed
CONST None$ = "<none>"
CONST Nul = ""
CONST PrimeKey = 29
CONST PublishDate = "10/20/2022"
CONST Release = "5.9a"
CONST Version = "64.0a"
CONST Untitled$ = "<untitled>"

' could be changed
CONST MorePrompt = "More(y/n/c)?"
CONST MorePrompt2 = "More(y/n)?"
CONST MorePrompt3 = "(y/n/q)?"
CONST MorePrompt4 = "-more-"

' global variables
DIM SHARED Allow.Alpha AS INTEGER
DIM SHARED Allow.Extra AS INTEGER
DIM SHARED Array.Size AS INTEGER
DIM SHARED Assign AS INTEGER
DIM SHARED ASCIIZ AS STRING * 260
DIM SHARED Boot.Error AS INTEGER
DIM SHARED CaseStrng AS STRING
DIM SHARED CaseValue AS DOUBLE
DIM SHARED CaseValue1 AS DOUBLE
DIM SHARED CaseValue2 AS DOUBLE
DIM SHARED CaseValueS1 AS STRING
DIM SHARED CaseValueS2 AS STRING
DIM SHARED CommandLine AS STRING
DIM SHARED ControlBreak AS INTEGER
DIM SHARED CurrentDirectory AS STRING
DIM SHARED CurrentDirectory2 AS STRING
DIM SHARED DataLine AS INTEGER
DIM SHARED DataNumber AS INTEGER
DIM SHARED DataValue AS DOUBLE
DIM SHARED Debug.Active AS INTEGER
DIM SHARED Debug.Mode AS INTEGER
DIM SHARED DEFSEGvalue AS DOUBLE
DIM SHARED DOSbox AS INTEGER
DIM SHARED ErrorLine AS INTEGER
DIM SHARED ErrorLine2 AS INTEGER
DIM SHARED ErrorType AS INTEGER
DIM SHARED ErrorValue AS INTEGER
DIM SHARED ExceptStep AS DOUBLE
DIM SHARED ExceptStepIs AS INTEGER
DIM SHARED FieldVariable AS INTEGER
DIM SHARED Filename AS STRING
DIM SHARED FileNumber AS INTEGER
DIM SHARED FinishFor AS DOUBLE
DIM SHARED Include.Recurse AS INTEGER
DIM SHARED Recurse AS INTEGER
DIM SHARED InDEFSEG AS INTEGER
DIM SHARED InDEFSEG2 AS INTEGER
DIM SHARED LastCursor1 AS INTEGER
DIM SHARED LastCursor2 AS INTEGER
DIM SHARED LastCursor3 AS INTEGER
DIM SHARED LastColor1 AS INTEGER
DIM SHARED LastColor2 AS INTEGER
DIM SHARED LastScreen1 AS INTEGER
DIM SHARED LastScreen2 AS INTEGER
DIM SHARED LastScreen3 AS INTEGER
DIM SHARED LastScreen4 AS INTEGER
DIM SHARED LastWidth1 AS INTEGER
DIM SHARED LastWidth2 AS INTEGER
DIM SHARED Last.Line AS INTEGER
DIM SHARED Last.Search.Case AS INTEGER
DIM SHARED Last.Search.Line AS INTEGER
DIM SHARED Last.Search.Keyword AS STRING
DIM SHARED Last.Token AS INTEGER
DIM SHARED Linux AS INTEGER
DIM SHARED LineFeed AS INTEGER
DIM SHARED ListLines AS INTEGER
DIM SHARED Max.Errors AS INTEGER
DIM SHARED Max.Row AS INTEGER
DIM SHARED Nested.Gosub AS INTEGER
DIM SHARED OperatingSystem AS STRING
DIM SHARED Out2 AS STRING
DIM SHARED Out3 AS STRING
DIM SHARED Out4 AS STRING
DIM SHARED Node AS INTEGER
DIM SHARED PageLength AS INTEGER
DIM SHARED Pipe.Buffer AS STRING * 1
DIM SHARED Printing AS INTEGER
DIM SHARED PrinterLF AS INTEGER
DIM SHARED Prepare.Filename AS STRING
DIM SHARED Program.Line AS INTEGER
DIM SHARED Program.Name AS STRING
DIM SHARED Program.Resume AS INTEGER
DIM SHARED Quote AS STRING * 1
DIM SHARED Quotes AS INTEGER
DIM SHARED Run.Line AS INTEGER
DIM SHARED Run.Type AS INTEGER
DIM SHARED StepTo AS DOUBLE
DIM SHARED SaveOnExit AS INTEGER
DIM SHARED ScreenHeight AS INTEGER
DIM SHARED ScreenMode AS INTEGER
DIM SHARED ScreenWidth AS INTEGER
DIM SHARED StdinEnabled AS INTEGER
DIM SHARED StdinInput1 AS INTEGER
DIM SHARED StdinInput2 AS STRING
DIM SHARED StdinPrompt AS INTEGER
DIM SHARED Supported.Call AS INTEGER
DIM SHARED Strng AS STRING
DIM SHARED TempX AS INTEGER
DIM SHARED Token AS INTEGER
DIM SHARED Token.Index AS INTEGER
DIM SHARED Token.List AS STRING
DIM SHARED Unless.Branch AS INTEGER
DIM SHARED Unless.Value AS DOUBLE
DIM SHARED ValueIs AS DOUBLE
DIM SHARED Visible AS INTEGER
DIM SHARED Var.Seg1 AS STRING
DIM SHARED Var.Seg2 AS DOUBLE
DIM SHARED White.Space AS STRING
DIM SHARED Windows.Detected AS INTEGER

' common interrupt registers
DIM SHARED AX AS DOUBLE
DIM SHARED BX AS DOUBLE
DIM SHARED CX AS DOUBLE
DIM SHARED DX AS DOUBLE
DIM SHARED BP AS DOUBLE
DIM SHARED SI AS DOUBLE
DIM SHARED DI AS DOUBLE
DIM SHARED FL AS DOUBLE
DIM SHARED DS AS DOUBLE
DIM SHARED ES AS DOUBLE

' array size
DIM SHARED Max.Lines AS INTEGER

' code areas
DIM SHARED Program(1) AS STRING ' storage space for .sic program

' subroutine area
DIM SHARED Renumber.List(1) AS INTEGER ' space for renumber subroutine

' temp directory
DIM SHARED DRX AS STRING

' declare program dta
DIM SHARED BASIC.DTA.SEG AS INTEGER, BASIC.DTA.OFF AS INTEGER

' declare prompt strings
DIM SHARED Prompt1 AS STRING
DIM SHARED Prompt2 AS STRING
DIM SHARED Prompt3 AS STRING

' -end include file-

