 REM Sicsub2.bas v8.7a r8.0 - Symbolic Instruction Code; module 3 of 3.
 REM The public domain DOS programming interpreter.

 ' get standard include declarations
 REM $INCLUDE: 'SIC.INC'

 ' playwav constants
 CONST PlayBuffer = 32767
 DIM SHARED SpeakerVolume AS INTEGER

 ' playwav variables
 COMMON SHARED BasePort%
 COMMON SHARED Channel%
 COMMON SHARED Byte AS STRING * 1
 COMMON SHARED WavBuffer() AS STRING * PlayBuffer

' accepts an operation and performs on two values, string or numeric
SUB Arith (Token.Parsed$, Temp#, Temp2#)
 IF Last.Token THEN
    SELECT CASE Token.Parsed$
    CASE "-"
       Temp# = Temp# - Temp2#
    CASE "+"
       Temp# = Temp# + Temp2#
    CASE "/"
       Temp# = Temp# / Temp2#
    CASE "\"
       Temp# = Temp# \ Temp2#
    CASE "*"
       Temp# = Temp# * Temp2#
    CASE "^"
       Temp# = Temp# ^ Temp2#
    CASE "<"
       Temp# = (Temp# < Temp2#)
    CASE ">"
       Temp# = (Temp# > Temp2#)
    CASE "<<"
       Temp# = Temp# * 2#
    CASE ">>"
       Temp# = Temp# \ 2#
    CASE "||"
       Temp# = Temp# * 10#
    CASE "##"
       Temp# = Temp# \ 10#
    CASE "^^"
       Temp# = Temp# ^ 10#
    CASE "++"
       Temp# = Temp# + 1#
    CASE "--"
       Temp# = Temp# - 1#
    CASE "**"
       Temp# = Temp# ^ 2#
    CASE "//"
       Temp# = SQR(Temp#)
    CASE "="
       If Temp# = Temp2# Then
          Temp# = -1#
       Else
          Temp# = 0#
       Endif
       'Temp# = (Temp# = Temp2#)
    CASE "<="
       Temp# = (Temp# <= Temp2#)
    CASE ">="
       Temp# = (Temp# >= Temp2#)
    CASE "<>"
       Temp# = (Temp# <> Temp2#)
    CASE "=="
       CaseValue1 = Temp#
       CaseValue2 = Temp2#
       Last.Token = 2
    CASE "|"
       Temp# = Temp# OR Temp2#
    CASE "&"
       Temp# = Temp# AND Temp2#
    CASE "%"
       Temp# = Temp# MOD Temp2#
    CASE "~"
       Temp# = Temp# XOR Temp2#
    CASE "?"
       Temp# = Temp# IMP Temp2#
    CASE ":"
       Temp# = Temp# EQV Temp2#
    CASE "#"
       Temp# = NOT (Temp# OR Temp2#)
    CASE "@"
       Temp# = NOT (Temp# IMP Temp2#)
    CASE "`"
       Temp# = NOT (Temp# AND Temp2#)
    END SELECT
    EXIT SUB
 END IF
 SELECT CASE Token.Parsed$
 CASE "-"
    IF RIGHT$(Out3, LEN(Out4)) = Out4 THEN
       Out3 = LEFT$(Out3, LEN(Out3) - LEN(Out4))
    END IF
 CASE "+"
    Out3 = Out3 + Out4
 CASE "/", "\"
    IF LEN(Out3) > False AND LEN(Out4) > False THEN
       Imbedded = INSTR(Out3, Out4)
       WHILE Imbedded
	  Out3 = LEFT$(Out3, Imbedded - 1) + MID$(Out3, Imbedded + LEN(Out4))
	  Imbedded = INSTR(Out3, Out4)
       WEND
    END IF
 CASE "<"
    Last.Token = True
    Temp# = Out3 < Out4
 CASE ">"
    Last.Token = True
    Temp# = Out3 > Out4
 CASE "="
    Last.Token = True
    Temp# = Out3 = Out4
 CASE "<="
    Last.Token = True
    Temp# = Out3 <= Out4
 CASE ">="
    Last.Token = True
    Temp# = Out3 >= Out4
 CASE "<>"
    Last.Token = True
    Temp# = Out3 <> Out4
 CASE "=="
    CaseValueS1 = Out3
    CaseValueS2 = Out4
    Last.Token = 2
 END SELECT
END SUB

' accepts an operation and performs on one numeric variable
SUB Assignment1 (TempS$, TempS3%)
 IF TempS$ = "<<" THEN
    Assign = True
    Strng = Nul
    Variables(TempS3%) = Variables(TempS3%) * 2#
    EXIT SUB
 END IF
 IF TempS$ = ">>" THEN
    Assign = True
    Strng = Nul
    Variables(TempS3%) = Variables(TempS3%) / 2#
    EXIT SUB
 END IF
 IF TempS$ = "||" THEN
    Assign = True
    Strng = Nul
    Variables(TempS3%) = Variables(TempS3%) * 10#
    EXIT SUB
 END IF
 IF TempS$ = "##" THEN
    Assign = True
    Strng = Nul
    Variables(TempS3%) = Variables(TempS3%) / 10#
    EXIT SUB
 END IF
 IF TempS$ = "^^" THEN
    Assign = True
    Strng = Nul
    Variables(TempS3%) = Variables(TempS3%) ^ 10#
    EXIT SUB
 END IF
 IF TempS$ = "--" THEN
    Assign = True
    Strng = Nul
    Variables(TempS3%) = Variables(TempS3%) - 1#
    EXIT SUB
 END IF
 IF TempS$ = "++" THEN
    Assign = True
    Strng = Nul
    Variables(TempS3%) = Variables(TempS3%) + 1#
    EXIT SUB
 END IF
 IF TempS$ = "**" THEN
    Assign = True
    Strng = Nul
    Variables(TempS3%) = Variables(TempS3%) ^ 2#
    EXIT SUB
 END IF
 IF TempS$ = "//" THEN
    Assign = True
    Strng = Nul
    Variables(TempS3%) = SQR(Variables(TempS3%))
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "-=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Variables(TempS3%) = Variables(TempS3%) - Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "+=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Variables(TempS3%) = Variables(TempS3%) + Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "/=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Variables(TempS3%) = Variables(TempS3%) / Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "\=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Variables(TempS3%) = Variables(TempS3%) \ Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "*=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Variables(TempS3%) = Variables(TempS3%) * Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "^=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Variables(TempS3%) = Variables(TempS3%) ^ Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 3) = "^-=" THEN
    Out2 = MID$(TempS$, 4)
    Out2 = STRIM$(Out2)
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Variables(TempS3%) = Variables(TempS3%) ^ (-Temp4#)
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "%=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Variables(TempS3%) = Variables(TempS3%) MOD Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "|=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Variables(TempS3%) = Variables(TempS3%) OR Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "&=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Variables(TempS3%) = Variables(TempS3%) AND Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "~=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Variables(TempS3%) = Variables(TempS3%) XOR Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "?=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Variables(TempS3%) = Variables(TempS3%) IMP Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = ":=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Variables(TempS3%) = Variables(TempS3%) EQV Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "#=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Variables(TempS3%) = NOT (Variables(TempS3%) OR Temp4#)
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "@=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Variables(TempS3%) = NOT (Variables(TempS3%) IMP Temp4#)
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "`=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Variables(TempS3%) = NOT (Variables(TempS3%) AND Temp4#)
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 1) = "=" THEN
    Out2 = MID$(TempS$, 2)
    Out2 = STRIM$(Out2)
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Variables(TempS3%) = Temp4#
    END IF
    EXIT SUB
 END IF
END SUB

' accepts an operation and performs on one numeric array element
SUB Assignment2 (TempS$, TempS1%, TempS2%)
 IF TempS$ = "<<" THEN
    Assign = True
    Strng = Nul
    Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) * 2#
    EXIT SUB
 END IF
 IF TempS$ = ">>" THEN
    Assign = True
    Strng = Nul
    Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) / 2#
    EXIT SUB
 END IF
 IF TempS$ = "||" THEN
    Assign = True
    Strng = Nul
    Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) * 10#
    EXIT SUB
 END IF
 IF TempS$ = "##" THEN
    Assign = True
    Strng = Nul
    Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) / 10#
    EXIT SUB
 END IF
 IF TempS$ = "^^" THEN
    Assign = True
    Strng = Nul
    Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) ^ 10#
    EXIT SUB
 END IF
 IF TempS$ = "--" THEN
    Assign = True
    Strng = Nul
    Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) - 1#
    EXIT SUB
 END IF
 IF TempS$ = "++" THEN
    Assign = True
    Strng = Nul
    Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) + 1#
    EXIT SUB
 END IF
 IF TempS$ = "**" THEN
    Assign = True
    Strng = Nul
    Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) ^ 2#
    EXIT SUB
 END IF
 IF TempS$ = "//" THEN
    Assign = True
    Strng = Nul
    Arrays(TempS1%, TempS2%) = SQR(Arrays(TempS1%, TempS2%))
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "-=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) - Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "+=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) + Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "/=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) / Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "\=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) \ Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "*=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) * Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "^=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) ^ Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 3) = "^-=" THEN
    Out2 = MID$(TempS$, 4)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) ^ (-Temp4#)
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "%=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) MOD Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "|=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) OR Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "&=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) AND Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "~=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) XOR Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "?=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) IMP Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = ":=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Arrays(TempS1%, TempS2%) = Arrays(TempS1%, TempS2%) EQV Temp4#
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "#=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Arrays(TempS1%, TempS2%) = NOT (Arrays(TempS1%, TempS2%) OR Temp4#)
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "@=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Arrays(TempS1%, TempS2%) = NOT (Arrays(TempS1%, TempS2%) IMP Temp4#)
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 2) = "`=" THEN
    Out2 = MID$(TempS$, 3)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Arrays(TempS1%, TempS2%) = NOT (Arrays(TempS1%, TempS2%) AND Temp4#)
    END IF
    EXIT SUB
 END IF
 IF LEFT$(TempS$, 1) = "=" THEN
    Out2 = MID$(TempS$, 2)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       Arrays(TempS1%, TempS2%) = Temp4#
    END IF
 END IF
END SUB

' gets a value and assigns to one register variable
SUB Assignment3 (TempS1$, TempS2$)
 SELECT CASE TempS2$
 CASE "AX"
    Out2 = TempS1$
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       AX = Temp4#
    END IF
    EXIT SUB
 CASE "BX"
    Out2 = TempS1$
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       BX = Temp4#
    END IF
    EXIT SUB
 CASE "CX"
    Out2 = TempS1$
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       CX = Temp4#
    END IF
    EXIT SUB
 CASE "DX"
    Out2 = TempS1$
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       DX = Temp4#
    END IF
    EXIT SUB
 CASE "BP"
    Out2 = TempS1$
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       BP = Temp4#
    END IF
    EXIT SUB
 CASE "SI"
    Out2 = TempS1$
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       SI = Temp4#
    END IF
    EXIT SUB
 CASE "DI"
    Out2 = TempS1$
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       DI = Temp4#
    END IF
    EXIT SUB
 CASE "FL"
    Out2 = TempS1$
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       FL = Temp4#
    END IF
    EXIT SUB
 CASE "DS"
    Out2 = TempS1$
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       DS = Temp4#
    END IF
    EXIT SUB
 CASE "ES"
    Out2 = TempS1$
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       ES = Temp4#
    END IF
    EXIT SUB
 END SELECT
END SUB

' gets a value and assigns to one error variable
SUB Assignment4 (TempS1$, TempS2$)
 SELECT CASE TempS2$
 CASE "ERR"
    Out2 = TempS1$
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       ErrorValue = CINT(Temp4#)
    END IF
    EXIT SUB
 CASE "ERL"
    Out2 = TempS1$
    CALL Equate(Temp4#)
    IF Last.Token = True THEN
       Assign = True
       ErrorLine = CINT(Temp4#)
    END IF
    EXIT SUB
  END SELECT
END SUB

' entry to expression parser,
' each following parser is higher precedence,
' this routine called by higher precedence routines recursively.

REM precedence of operators (from highest to lowest):
REM   !, +, - Not, Unary plus, Unary Minus
REM   ^       Power
REM   *, /    Multiplication, Division
REM   \       Integer division
REM   %       Modulo
REM   +, -    Addition, Subtraction
REM   =, <, >, <>, >=, <= Relational
REM   |, &, ~, ?, :, #, @, ` Logical (or, and, xor, imp, eqv, nor, non, xan)

REM  Returns Last.Token equal to:
REM    0  =  string
REM   -1  =  numeric
REM    1  =  token IS/ISNT
REM    2  =  token is ==

SUB Equate (Temp#)
 Last.Token = False
 Out3 = Nul ' reset string storage
 Out4 = Nul ' reset string concatenate storage
 Temp# = DFalse ' reset result
 Token.Index = 1 ' reset pointer to expression token
 CALL Get.Token ' read next token
 CALL Parse1(Temp#) ' entry to parse the expression
 ' parse leftover tokens
 WHILE LEN(Strng)
    CALL Parse1(X#)
    ' toss away any unwanted tokens
    IF Last.Token = 3 THEN
       IF Allow.Extra = False THEN
          Strng = "<extra token>"
          ERROR 92
       END IF
    END IF
 WEND
END SUB

' verifies next token is opening parenthesis.
SUB Get.Token3
 Strng = Nul
 Token = False
 IF MID$(Out2, Token.Index, 1) = " " THEN
    Token.Index = Token.Index + 1
 END IF
 IF Token.Index > LEN(Out2) THEN
    ERROR 138
 END IF
 ' locate parenthesis symbol
 Token.Element$ = MID$(Out2, Token.Index, 1)
 IF Token.Element$ = "(" THEN
    Token = 1 ' store token type
    Strng = Token.Element$ ' store token
    Token.Index = Token.Index + 1 ' increment pointer
    EXIT SUB
 END IF
 ERROR 138
END SUB

' verifies last token is closing parenthesis.
SUB Get.Token4
 ' locate parenthesis symbol
 IF Strng = ")" THEN
    EXIT SUB
 END IF
 ERROR 139
END SUB

' returns next token in string form,
' increments pointer to next token,
' determines token type.
SUB Get.Token
 Strng = Nul
 Token = False
 IF MID$(Out2, Token.Index, 1) = " " THEN
    Token.Index = Token.Index + 1
 END IF
 CALL Get.Token2(Token.Exists)
 IF Token.Exists THEN
    EXIT SUB
 END IF
 IF Token.Index > LEN(Out2) THEN
    Strng = Nul
    Token = False
    Token.Index = Token.Index + 1
    EXIT SUB
 END IF
 ' locate expression symbol
 Token.Element$ = MID$(Out2, Token.Index, 1)
 IF INSTR(Token.List, Token.Element$) THEN
    Token = 1 ' store token type
    Strng = Token.Element$ ' store token
    Token.Index = Token.Index + 1 ' increment pointer
    EXIT SUB
 END IF
 ' locate expression is number
 Token.Element$ = MID$(Out2, Token.Index, 1)
 IF Token.Element$ >= "0" AND Token.Element$ <= "9" THEN
    ' increment token until token is other than number
    DO
       IF LEN(Token.Element$) = False THEN
	  EXIT DO
       END IF
       IF INSTR(Token.List, Token.Element$) THEN
	  EXIT DO
       END IF
       Strng = Strng + Token.Element$
       Token.Index = Token.Index + 1
       Token.Element$ = MID$(Out2, Token.Index, 1)
    LOOP
    Token = 2 ' store token type
    EXIT SUB
 END IF
 ' locate expression is number beginning with decimal
 Token.Element$ = MID$(Out2, Token.Index, 1)
 IF Token.Element$ = "." THEN
    ' increment token until token is other than number
    DO
       IF LEN(Token.Element$) = False THEN
	  EXIT DO
       END IF
       IF INSTR(Token.List, Token.Element$) THEN
	  EXIT DO
       END IF
       Strng = Strng + Token.Element$
       Token.Index = Token.Index + 1
       Token.Element$ = MID$(Out2, Token.Index, 1)
    LOOP
    Token = 2 ' store token type
    EXIT SUB
 END IF
 ' locate expression is alphabetic
 Token.Element$ = UCASE$(MID$(Out2, Token.Index, 1))
 IF Token.Element$ >= "A" AND Token.Element$ <= "Z" THEN
    ' increment token until token is other than alphabetic
    DO
       IF LEN(Token.Element$) = False THEN
	  EXIT DO
       END IF
       IF INSTR(Token.List, Token.Element$) THEN
	  EXIT DO
       END IF
       Strng = Strng + Token.Element$
       Token.Index = Token.Index + 1
       Token.Element$ = UCASE$(MID$(Out2, Token.Index, 1))
    LOOP
    Token = 3 ' store token type
    EXIT SUB
 END IF
 ' store unknown token
 Token = False
 Strng = Token.Element$
 Token.Index = Token.Index + 1
END SUB

' returns next two-character token in string form,
' increments pointer to next token,
' determines token type.
SUB Get.Token2 (Token.Exists)
 Token.Exists = False
 Stored.Token$ = Out2
 IF MID$(Stored.Token$, Token.Index + 1, 1) = " " THEN
    Stored.Token$ = LEFT$(Stored.Token$, Token.Index) + MID$(Stored.Token$, Token.Index + 2)
 END IF
 ' locate expression symbols
 Next.Token$ = MID$(Stored.Token$, Token.Index, 2)
 SELECT CASE Next.Token$
 CASE "<<"
    GOSUB Remove.Spaces
    Token = 1 ' store token type
    Strng = "<<" ' store token
    Token.Index = Token.Index + 2 ' increment pointer
    Token.Exists = True
 CASE ">>"
    GOSUB Remove.Spaces
    Token = 1 ' store token type
    Strng = ">>" ' store token
    Token.Index = Token.Index + 2 ' increment pointer
    Token.Exists = True
 CASE "||"
    GOSUB Remove.Spaces
    Token = 1 ' store token type
    Strng = "||" ' store token
    Token.Index = Token.Index + 2 ' increment pointer
    Token.Exists = True
 CASE "##"
    GOSUB Remove.Spaces
    Token = 1 ' store token type
    Strng = "##" ' store token
    Token.Index = Token.Index + 2 ' increment pointer
    Token.Exists = True
 CASE "^^"
    GOSUB Remove.Spaces
    Token = 1 ' store token type
    Strng = "^^" ' store token
    Token.Index = Token.Index + 2 ' increment pointer
    Token.Exists = True
 CASE "--"
    GOSUB Remove.Spaces
    Token = 1 ' store token type
    Strng = "--" ' store token
    Token.Index = Token.Index + 2 ' increment pointer
    Token.Exists = True
 CASE "++"
    GOSUB Remove.Spaces
    Token = 1 ' store token type
    Strng = "++" ' store token
    Token.Index = Token.Index + 2 ' increment pointer
    Token.Exists = True
 CASE "**"
    GOSUB Remove.Spaces
    Token = 1 ' store token type
    Strng = "**" ' store token
    Token.Index = Token.Index + 2 ' increment pointer
    Token.Exists = True
 CASE "//"
    GOSUB Remove.Spaces
    Token = 1 ' store token type
    Strng = "//" ' store token
    Token.Index = Token.Index + 2 ' increment pointer
    Token.Exists = True
 CASE ">=", "=>"
    GOSUB Remove.Spaces
    Token = 1 ' store token type
    Strng = ">=" ' store token
    Token.Index = Token.Index + 2 ' increment pointer
    Token.Exists = True
 CASE "<=", "=<"
    GOSUB Remove.Spaces
    Token = 1 ' store token type
    Strng = "<=" ' store token
    Token.Index = Token.Index + 2 ' increment pointer
    Token.Exists = True
 CASE "<>", "><"
    GOSUB Remove.Spaces
    Token = 1 ' store token type
    Strng = "<>" ' store token
    Token.Index = Token.Index + 2 ' increment pointer
    Token.Exists = True
 CASE "=="
    GOSUB Remove.Spaces
    Token = 1 ' store token type
    Strng = "==" ' store token
    Token.Index = Token.Index + 2 ' increment pointer
    Token.Exists = True
 END SELECT
 EXIT SUB
Remove.Spaces:
 ' locate space
 IF MID$(Out2, Token.Index + 1, 1) = " " THEN
    Out2 = LEFT$(Out2, Token.Index) + MID$(Out2, Token.Index + 2)
 END IF
 RETURN
END SUB

' parses out single variable tokens
SUB Parse.Alphabetic1 (Temp#)
 SELECT CASE UCASE$(Strng) ' test variable symbol
 CASE "A" TO "Z"
    Element = ASC(UCASE$(Strng)) - 64
    Element.Type$ = MID$(Out2, Token.Index, 1)
    SELECT CASE Element.Type$
    CASE "("
       CALL Get.Token
       CALL Get.Token
       CALL Parse1(Temp#)
       IF Strng = ")" THEN
          Temp# = Arrays(Element, CINT(Temp#))
          Last.Token = True
       ELSE
          Strng = "<missing closing token>"
          ERROR 92
       END IF
    CASE "["
       CALL Get.Token
       CALL Get.Token
       CALL Parse1(Temp#)
       IF Strng = "]" THEN
          Temp# = Arrays(Element, CINT(Temp#))
          Last.Token = True
       ELSE
          Strng = "<missing closing token>"
          ERROR 92
       END IF
    CASE "{"
       CALL Get.Token
       CALL Get.Token
       CALL Parse1(Temp#)
       IF Strng = "}" THEN
          Temp# = Arrays(Element, CINT(Temp#))
          Last.Token = True
       ELSE
          Strng = "<missing closing token>"
          ERROR 92
       END IF
    CASE ELSE
       Temp# = Cdbl(Variables(Element))
       Last.Token = True
    END SELECT
 CASE ELSE
    IF Allow.Alpha THEN
       Out3 = Strng
    ELSE
       Strng = "(" + Strng + ")"
       ERROR 92
    END IF
 END SELECT
END SUB

' parses out two-letter variable tokens
SUB Parse.Alphabetic2 (Temp#)
 SELECT CASE UCASE$(Strng)
 ' user defined functions
 CASE "FN"
    CALL ParseFN (Temp#)
 CASE "FZ"
    CALL ParseFZ (Temp#)
 ' interrupt functions
 CASE "AX"
    Temp# = AX
    Last.Token = True
 CASE "BX"
    Temp# = BX
    Last.Token = True
 CASE "CX"
    Temp# = CX
    Last.Token = True
 CASE "DX"
    Temp# = DX
    Last.Token = True
 CASE "BP"
    Temp# = BP
    Last.Token = True
 CASE "SI"
    Temp# = SI
    Last.Token = True
 CASE "DI"
    Temp# = DI
    Last.Token = True
 CASE "FL"
    Temp# = FL
    Last.Token = True
 CASE "DS"
    Temp# = DS
    Last.Token = True
 CASE "ES"
    Temp# = ES
    Last.Token = True
 ' functions w/o parameters
 CASE "PI" ' calculate PI
    Temp# = ATN(1#) * 4#
    Last.Token = True
 CASE "EX" ' calculate E
    Temp# = EXP(1#)
    Last.Token = True
 ' special case functions
 CASE "IS"
    CALL Get.Token
    Strng2$ = Strng
    CALL Get.Token
    CALL Parse1(Temp4#)
    Out4 = Out3
    Temp3# = CaseValue
    Out3 = CaseStrng
    Strng = Strng2$
    CALL Arith(Strng, Temp3#, Temp4#)
    ValueIs = Temp3#
    Last.Token = 1
 CASE "OR"
    CALL Get.Token
    CALL Get.Token
    CALL Parse1(Temp#)
    Number# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = Number# OR Temp#
    Last.Token = True
 ' special case constants
 CASE "CR"
    Out3 = CHR$(13)
    Last.Token = False
 CASE "LF"
    Out3 = CHR$(10)
    Last.Token = False
 CASE ELSE
    IF MID$(Strng, 2, 1) = "$" THEN
       SELECT CASE MID$(Out2, Token.Index, 1)
       CASE "(", "[", "{"
          Strng = "<bad string token>"
          ERROR 92
       END SELECT
       SELECT CASE UCASE$(LEFT$(Strng, 1))
       CASE "A" TO "Z"
	  Element = ASC(UCASE$(LEFT$(Strng, 1))) - 64
	  Out3 = Strngs(Element)
	  Last.Token = False
       END SELECT
    ELSE
       IF Allow.Alpha THEN
	  Out3 = Strng
       ELSE
          Strng = "[" + Strng + "]"
	  ERROR 92
       END IF
    END IF
 END SELECT
END SUB

' parses FN(<x>)
SUB ParseFN (Temp#)
 Var$ = LEFT$(Out2, Token.Index - 3)
 CALL Get.Token3
 CALL Get.Token
 CALL Parse1(Temp4#)
 CALL Get.Token4
 Func% = CINT(Temp4#)
 IF Func% >= 1 AND Func% <= Max.Functions THEN
    Var2$ = MID$(Out2, Token.Index)
    Out2 = Definitions(Func%)
    Out2 = STRIM$(Out2)
    ' test for nul token
    IF Out2 = Nul THEN
       Strng = "<bad FN token>"
       ERROR 148
    END IF
    ' count recursing calls
    Recurse = Recurse + 1
    IF Recurse > Max.Recurse THEN
       Strng = "<bad FN recurse>"
       ERROR 148
    END IF
    ' recursively call functions
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp#)
    ' test huge recursed FN
    IF LEN(Var$) + LEN(Var2$) >= Max.FN.Length THEN
       Var$ = Nul
       Var2$ = Nul
       Strng = "<bad FN string>
       ERROR 148
    END IF
    ' re-concatenate equation
    Out2 = Var$ + Var2$
    Token.Index = LEN(Var$) + 1
    EXIT SUB
 END IF
 Strng = "<bad FN range>"
 ERROR 148
END SUB

' parses FZ(<x>)
SUB ParseFZ (Temp#)
 CALL Get.Token3
 CALL Get.Token
 CALL Parse1(Temp4#)
 CALL Get.Token4
 Func% = CINT(Temp4#)
 IF Func% >= 1 AND Func% <= Max.Functions THEN
    Out3 = Definitions(Func%)
    Out3 = STRIM$(Out3)
    IF Out3 = Nul THEN
       Strng = "<bad FN token>"
       ERROR 149
    END IF
    Last.Token = False
    EXIT SUB
 END IF
 Strng = "<bad FN range>"
 ERROR 149
END SUB

' parses out three-letter and greater variable tokens
SUB Parse.Alphabetic3 (Temp#)
 DIM Default.Net AS STRING * 16
 SELECT CASE UCASE$(Strng)
 ' special purpose functions
 CASE "ISNT"
    CALL Get.Token
    Strng2$ = Strng
    CALL Get.Token
    CALL Parse1(Temp4#)
    Out4 = Out3
    Temp3# = CaseValue
    Out3 = CaseStrng
    Strng = Strng2$
    CALL Arith(Strng, Temp3#, Temp4#)
    ValueIs = NOT Temp3#
    Last.Token = 1
 CASE "POINT"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Xcoor# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Ycoor# = Temp#
    Temp# = POINT(Xcoor#, Ycoor#)
    CALL Get.Token4
    Last.Token = True
 CASE "SCREEN"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Xcoor = cint(Temp#)
    CALL Get.Token
    CALL Parse1(Temp#)
    Ycoor = cint(Temp#)
    Temp# = SCREEN(Xcoor, Ycoor)
    CALL Get.Token4
    Last.Token = True
 CASE "SCREENX"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Xcoor = cint(Temp#)
    CALL Get.Token
    CALL Parse1(Temp#)
    Ycoor = cint(Temp#)
    Temp# = SCREEN(Xcoor, Ycoor, 1)
    CALL Get.Token4
    Last.Token = True
 ' functions w/o parameters
 CASE "FALSE"
    Temp# = DFalse
    Last.Token = True
 CASE "TRUE"
    Temp# = DTrue
    Last.Token = True
 CASE "QUOTE$"
    Out3 = CHR$(34)
    Last.Token = False
 CASE "FREEFILE"
    File.Num = FREEFILE
    IF File.Num >= 1 AND File.Num <= MaxFiles THEN
       Temp# = CDBL(File.Num)
    ELSE
       Temp# = DFalse
    END IF
    Last.Token = True
 CASE "RND"
    Temp# = RND
    Last.Token = True
 CASE "CRLF"
    Out3 = CHR$(13) + CHR$(10)
    Last.Token = False
 CASE "POS"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = POS(0)
    CALL Get.Token4
    Out3 = Nul
    Last.Token = True
 CASE "CSRLIN"
    Temp# = CSRLIN
    Last.Token = True
 CASE "ERR"
    Temp# = CLNG(ErrorValue)
    Last.Token = True
 CASE "ERL"
    Temp# = CLNG(ErrorLine)
    Last.Token = True
 CASE "ARRAYSIZE"
    Temp# = CDBL(Array.Size)
    Last.Token = True
 ' boolean functions
 CASE "AND"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = Number# AND Temp#
    CALL Get.Token4
    Last.Token = True
 CASE "MOD"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = Number# MOD Temp#
    CALL Get.Token4
    Last.Token = True
 CASE "NOR"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = NOT (Number# OR Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "NON"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = NOT (Number# IMP Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "XAN"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = NOT (Number# AND Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "XOR"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = Number# XOR Temp#
    CALL Get.Token4
    Last.Token = True
 CASE "IMP"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = Number# IMP Temp#
    CALL Get.Token4
    Last.Token = True
 CASE "EQV"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = Number# EQV Temp#
    CALL Get.Token4
    Last.Token = True
 CASE "NOT"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = NOT Temp#
    CALL Get.Token4
    Last.Token = True
 ' third-order boolean
 CASE "TAND"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number1# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Number2# = Temp#
    CALL Get.Token4
    SELECT CASE Number1#
    CASE -1,0,1
       SELECT CASE Number2#
       CASE -1,0,1
          Temp# = Number1# AND Number2#
          Last.Token = True
          EXIT SUB
       END SELECT
    END SELECT
    ERROR 2
 CASE "TOR"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number1# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Number2# = Temp#
    CALL Get.Token4
    SELECT CASE Number1#
    CASE -1,0,1
       SELECT CASE Number2#
       CASE -1,0,1
          Temp# = Number1# OR Number2#
          Last.Token = True
          EXIT SUB
       END SELECT
    END SELECT
    ERROR 2
 CASE "TXOR"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number1# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Number2# = Temp#
    CALL Get.Token4
    SELECT CASE Number1#
    CASE -1,0,1
       SELECT CASE Number2#
       CASE -1,0,1
          Temp# = Number1# XOR Number2#
          Last.Token = True
          EXIT SUB
       END SELECT
    END SELECT
    ERROR 2
 ' data constants
 CASE "DATALINE"
    Temp# = DataLine
    Last.Token = True
 CASE "DATANUMBER"
    Temp# = DataNumber
    Last.Token = True
 ' date/time functions
 CASE "DATE$"
    Out3 = DATE$
    Last.Token = False
 CASE "TIME$"
    Out3 = TIME$
    Last.Token = False
 CASE "CLOCK"
    Temp# = TIMER
    Last.Token = True
 CASE "NOW"
    Temp# = NOW
    Last.Token = True
 CASE "TIMER"
    Temp# = TIMER
    Last.Token = True

 ' serial date/time functions
 CASE "DATESERIAL" ' DateSerial#(year%, month%, day%)
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp1 = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp2 = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp3 = Temp#
    CALL Get.Token4
    Temp# = DateSerial(Temp1,Temp2,Temp3)
    Last.Token = True
 CASE "TIMESERIAL" ' TimeSerial#(hour%, minute%, second%)
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp1 = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp2 = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp3 = Temp#
    CALL Get.Token4
    Temp# = TimeSerial(Temp1,Temp2,Temp3)
    Last.Token = True
 CASE "DATEVALUE"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = DateValue(Out3)
    CALL Get.Token4
    Last.Token = True
 CASE "TIMEVALUE"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = TimeValue(Out3)
    CALL Get.Token4
    Last.Token = True
 CASE "HOUR"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = Hour(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "MINUTE"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = Minute(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "SECOND"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = Second(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "DAY"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = Day(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "MONTH"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = Month(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "YEAR"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = Year(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "WEEKDAY"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = Weekday(Temp#)
    CALL Get.Token4
    Last.Token = True

 ' input functions
 CASE "INKEY$"
    ' check if program is redirected
    IF Program.Resume = 1 THEN
       ' store environment input character
       IF StdinInput1 THEN
          Out3 = CHR$(StdinInput1)
       ELSE
          Out3 = Nul
       END IF
    ELSE
       ' read keyboard directly
       LOCATE , , Visible
       IF KeyIS THEN
          Out3 = KeyboardChar$
       ELSE
          Out3 = Nul
       END IF
    END IF
    Last.Token = False
 CASE "INPUT$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    IF Temp# <= 0# OR Temp# > 32767# THEN
       ERROR 2 ' syntax error
    END IF
    Chars% = CINT(Temp#)
    IF Strng = "," THEN
       CALL Get.Token
       CALL Parse1(Temp#)
       File.Num = CINT(Temp#)
       IF File.Num <=0 OR File.Num > MaxFiles THEN
          ERROR 126
          EXIT SUB
       END IF
       If FileTraps(File.Num) Then
          ControlBreak = -2
          Exit Sub
       End If
       Out3 = INPUT$(Chars%, File.Num)
    ELSE
       ' check if program is redirected
       IF Program.Resume = 1 THEN
          ' store environment input character
          IF LEN(StdinInput2) THEN
             Out3 = StdinInput2
          ELSE
             Out3 = Nul
          END IF
       ELSE
          ' read keyboard directly
          LOCATE , , Visible
          Out3 = Nul
          DO
             IF KeyIS THEN ' test keyboard
                Out3 = Out3 + KeyboardChar$ ' get character
                IF LEN(Out3) >= Chars% THEN ' check length
                   EXIT DO
                END IF
             END IF

             ' exit input loop for control-break
             IF ControlBreak THEN
                EXIT DO
             END IF
          LOOP
       END IF
    END IF
    CALL Get.Token4
    Last.Token = False
 ' special input loop time slice releaser
 CASE "SLICE$"
    Out3 = Nul
    Last.Token = False
    CALL Release.Time(1)
 ' special lprint functions
 CASE "LPOS"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    VarX=Cint(Temp#)
    If VarX>=0 And VarX<=3 Then
       Temp#=Lpos(VarX)
    Else
       Error 161
    Endif
    CALL Get.Token4
    Out3 = Nul
    Last.Token = True
 CASE "LPRINT"
    Out3 = "LPRINT"
    Last.Token = False
 ' special debug constants
 CASE "TEMPDIR$"
    Out3 = DRX$
    Last.Token = False
 CASE "NODE"
    Temp# = Node
    Last.Token = True
 CASE "DEBUG"
    Temp# = Debug.Active
    Last.Token = True
 CASE "LLINES"
    Temp# = ListLines
    Last.Token = True
 CASE "LBOUND"
    Temp# = 1
    Last.Token = True
 CASE "UBOUND"
    Temp# = Max.Arrays
    Last.Token = True
 ' special sound function
 CASE "WAV"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    IF Last.Token THEN ' numeric
       VarX=Cint(Temp#)
       If VarX>=1 And VarX<=12 Then
          Call Playwav(VarX,"")
       Else
          Error 5
       Endif
    Else
       Error 5
    Endif
    CALL Get.Token4
    Temp#=-1#
    Out3 = Nul
    Last.Token = True
 CASE "WAV$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    IF Last.Token = 0 THEN ' string
       VarX$=Out3
       Call Playwav(0,VarX$)
    Else
       Error 5
    Endif
    CALL Get.Token4
    Temp#=-1#
    Out3 = Nul
    Last.Token = True
 ' conversion/calculation functions
 CASE "BIN$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = Nul
    IF Temp# >= False THEN
       Digits = False
       DO
	  IF 2 ^ (Digits + 1) > Temp# THEN
	     EXIT DO
	  END IF
	  Digits = Digits + 1
       LOOP
       FOR Power = Digits TO 0 STEP -1
	  IF Temp# - 2 ^ Power >= False THEN
	     Temp# = Temp# - 2 ^ Power
	     Out3 = Out3 + "1"
	  ELSE
	     Out3 = Out3 + "0"
	  END IF
       NEXT
    END IF
    CALL Get.Token4
    Last.Token = False
 CASE "CHR$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = CHR$(Temp#)
    CALL Get.Token4
    Last.Token = False
 CASE "HEX$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = HEX$(Temp#)
    CALL Get.Token4
    Last.Token = False
 CASE "OCT$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = OCT$(Temp#)
    CALL Get.Token4
    Last.Token = False
 CASE "STR$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = STR$(Temp#)
    CALL Get.Token4
    Last.Token = False
 CASE "LCASE$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = LCASE$(Out3)
    CALL Get.Token4
    Last.Token = False
 CASE "UCASE$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = UCASE$(Out3)
    CALL Get.Token4
    Last.Token = False
 CASE "LTRIM$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = LTRIM$(Out3)
    CALL Get.Token4
    Last.Token = False
 CASE "RTRIM$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = RTRIM$(Out3)
    CALL Get.Token4
    Last.Token = False
 CASE "TRIM$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = LTRIM$(Out3)
    Out3 = RTRIM$(Out3)
    CALL Get.Token4
    Last.Token = False
 CASE "STRIM$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = STRIM$(Out3)
    CALL Get.Token4
    Last.Token = False
 CASE "TTRIM$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = LTRIM$(Out3)
    Out3 = RTRIM$(Out3)
    Out3 = TTRIM$(Out3, True)
    CALL Get.Token4
    Last.Token = False
 CASE "UTRIM$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = LTRIM$(Out3)
    Out3 = RTRIM$(Out3)
    Out3 = TTRIM$(Out3, False)
    CALL Get.Token4
    Last.Token = False
 CASE "XTRIM$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = LTRIM$(Out3)
    Out3 = RTRIM$(Out3)
    Out3 = XTRIM$(Out3, True)
    CALL Get.Token4
    Last.Token = False
 CASE "ZTRIM$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = LTRIM$(Out3)
    Out3 = RTRIM$(Out3)
    Out3 = XTRIM$(Out3, False)
    CALL Get.Token4
    Last.Token = False
 CASE "STRIP$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    FOR Var1 = 1 TO LEN(White.Space)
       V$ = MID$(White.Space, Var1, 1)
       WHILE INSTR(Out3, V$)
          Var2 = INSTR(Out3, V$)
          Out3 = LEFT$(Out3, Var2 - 1) + MID$(Out3, Var2 + 1)
       WEND
    NEXT
    CALL Get.Token4
    Last.Token = False
 CASE "SPACE$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = SPACE$(CINT(Temp#))
    CALL Get.Token4
    Last.Token = False
 CASE "FORMATS$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = FormatString$(Temp#)
    CALL Get.Token4
    Last.Token = False
 CASE "FORMAT$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Value# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = FORMAT$(Value#, Out3)
    CALL Get.Token4
    Last.Token = False
 CASE "MID$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Stored.String$ = Out3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp4# = Temp#
    IF Strng = "," THEN
       CALL Get.Token
       CALL Parse1(Temp#)
       Length# = Temp#
       Out3 = MID$(Stored.String$, Temp4#, Length#)
    ELSE
       Out3 = MID$(Stored.String$, Temp4#)
    END IF
    CALL Get.Token4
    Last.Token = False
 CASE "REMID$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Stored.String$ = Out3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp4# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Length# = Temp#
    Out3 = LEFT$(Stored.String$, Temp4# - 1) + MID$(Stored.String$, Temp4# + Length#)
    CALL Get.Token4
    Last.Token = False
 CASE "DEMID$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    String1$ = Out3
    CALL Get.Token
    CALL Parse1(Temp#)
    IF LEN(String1$) > False AND LEN(Out3) > False THEN
       Imbedded = INSTR(String1$, Out3)
       WHILE Imbedded
          String1$ = LEFT$(String1$, Imbedded - 1) + MID$(String1$, Imbedded + LEN(Out3))
	  Imbedded = INSTR(String1$, Out3)
       WEND
    END IF
    Out3 = String1$
    CALL Get.Token4
    Last.Token = False
 CASE "REPLACE$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    String1$ = Out3
    CALL Get.Token
    CALL Parse1(Temp#)
    String2$ = Out3
    CALL Get.Token
    CALL Parse1(Temp#)
    String3$ = Out3
    IF String1$ = Nul OR String2$ = Nul OR String2$ = String3$ THEN
       Out3 = String1$
       EXIT SUB
    END IF
    Temp1 = 1
    DO
       IF String1$ = Nul THEN
	  EXIT DO
       END IF
       Var1 = INSTR(Temp1, String1$, String2$)
       IF Var1 = False THEN
	  EXIT DO
       END IF
       String1$ = LEFT$(String1$, Var1 - 1) + String3$ + MID$(String1$, Var1 + LEN(String2$))
       Temp1 = Temp1 + LEN(String3$)
    LOOP
    Out3 = String1$
    CALL Get.Token4
    Last.Token = False
 CASE "LEFT$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Stored.String$ = Out3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = LEFT$(Stored.String$, Temp#)
    CALL Get.Token4
    Last.Token = False
 CASE "RIGHT$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Stored.String$ = Out3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = RIGHT$(Stored.String$, Temp#)
    CALL Get.Token4
    Last.Token = False
 CASE "STRING$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    IF Last.Token THEN
       Out3 = STRING$(Number#, Temp#)
    ELSE
       Out3 = STRING$(Number#, Out3)
    END IF
    CALL Get.Token4
    Last.Token = False
 CASE "ENCRYPT$"
    Prime.Key = PrimeKey
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    V$ = Out3
    Token2 = Last.Token
    IF Strng = "," THEN
       CALL Get.Token
       CALL Parse1(Temp2#)
       Prime.Key = Temp2#
    END IF
    Out3 = V$
    IF Token2 THEN
       Out3 = CHR$(Temp# Xor Prime.Key)
    Else
       For V = 1 To Len(Out3)
          Mid$(Out3,V,1) = Chr$(Asc(Mid$(Out3,V,1)) Xor Prime.Key)
       Next
    Endif
    CALL Get.Token4
    Last.Token = False
 ' constant functions
 CASE "MELODY$"
    Out3 = "o3 L8 E D+ E D+ E o2 B o3 D C L2 o2 A"
    Last.Token = False
 CASE "AUTHOR$"
    Out3 = Statements(MaxStatements+1)
    Last.Token = False
 CASE "EMAIL$"
    Out3 = Statements(MaxStatements+2)
    Last.Token = False
 CASE "URL$"
    Out3 = Statements(MaxStatements+3)
    Last.Token = False
 CASE "VERSION$"
    Out3 = Version
    Last.Token = False
 CASE "RELEASE$"
    Out3 = Release
    Last.Token = False
 CASE "COMMAND$"
    Out3 = CommandLine
    Last.Token = False
 CASE "PROGRAM$"
    Out3 = Program.Name
    Last.Token = False
 CASE "PUBLISH$"
    Out3 = PublishDate
    Last.Token = False
 CASE "COOKIE$"
    IF RND > .5 THEN
       Out3 = "No one cares what the code looks like as long as it works!"
    ELSE
       Out3 = "You owe me a sugar cookie for writing this program and I want it now!!"
    END IF
    Last.Token = False
 CASE "ERROR"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    ERROR CINT(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "OS$"
    Out3 = OperatingSystem
    Last.Token = False
 CASE "MACHINE$"
    Default.Net = Nul
    InregsX.AX = &H5E00
    InregsX.DS = VARSEG(Default.Net)
    InregsX.DX = VARPTR(Default.Net)
    CALL InterruptX(&H21, InregsX, OutregsX)
    ' check error flag
    IF (OutregsX.Flags AND &H1) = &H0 THEN
       ' read CH
       VarS = (OutregsX.CX AND &HFF00) / 256
       IF VarS > 0 THEN ' valid name
          ' store default server name
          Imbedded = INSTR(Default.Net, CHR$(0))
          IF Imbedded THEN
             Default.Net = LEFT$(Default.Net, Imbedded - 1)
          END IF
       END IF
    END IF
    Out3 = UCASE$(RTRIM$(Default.Net))

    ' check net path.
    If Out3 = Nul Then
       Var$ = Environ$("COMPUTERNAME")
       If Len(Var$) Then
          Out3 = Var$
       Endif
    Endif
    Last.Token = False
 ' numeric/string constant functions
 CASE "LASTLINE"
    Temp#=Last.Line
    Last.Token = True
 CASE "LINENUMBER"
    Temp# = Program.Line
    Last.Token = True
 CASE "PRIMEKEY"
    Temp# = PrimeKey
    Last.Token = True
 CASE "TICKS"
    Temp# = 18.20648
    Last.Token = True
 CASE "MAXINT"
    Temp# = 32766#
    Last.Token = True
 CASE "PROGRAMLINE"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Var2 = CINT(Temp#)
    IF Var2 > False AND Var2 <= Max.Lines THEN
       IF LEN(Program(Var2)) <> False THEN
          Out3 = Program(Var2)
       END IF
    END IF
    CALL Get.Token4
    Last.Token = False
 CASE "HISTORYCOUNT"
    CALL Get.Token
    CALL Get.Token
    CALL Parse1(Temp#)
    Var1 = CINT(Temp#)
    IF Var1 >= 1 AND Var1 <= 3 THEN
       Temp# = History.Count2(Var1)
    END IF
    CALL Get.Token4
    Last.Token = True
 CASE "HISTORY"
    CALL Get.Token
    CALL Get.Token
    CALL Parse1(Temp#)
    Var1 = CINT(Temp#)
    CALL Get.Token
    CALL Parse1(Temp#)
    Var2 = CINT(Temp#)
    IF Var1 >= 1 AND Var1 <= 3 THEN
       IF Var2 > False AND Var2 <= Max.History THEN
          IF LEN(RTRIM$(History2(Var1,Var2))) <> False THEN
             Out3 = RTRIM$(History2(Var1,Var2))
          END IF
       END IF
    END IF
    CALL Get.Token4
    Last.Token = False
 CASE "MAXARRAYS"
    Temp#=Max.Arrays
    Last.Token = True
 CASE "MAXFUNCTIONS"
    Temp#=Max.Functions
    Last.Token = True
 CASE "MAXHISTORY"
    Temp#=Max.History
    Last.Token = True
 CASE "MAXLINES"
    Temp#=Max.Lines
    Last.Token = True
 CASE "MAXFNLENGTH"
    Temp# = Max.FN.Length
    LastToken = True
 CASE "MAXNESTGOSUB"
    Temp# = Max.Nest.Gosub
    LastToken = True
 CASE "MAXRECURSE"
    Temp# = Max.Recurse
    LastToken = True
 ' keyboard shift state
 CASE "FLAGS"
    DEF SEG = 0
    Temp# = PEEK(&H417)
    Last.Token = True
    IF InDEFSEG THEN
       DEF SEG = DEFSEGvalue
    ELSE
       DEF SEG
    END IF
 ' break flag
 CASE "BREAK"
    DEF SEG = &H40
    X = PEEK(&H71)
    POKE &H71, &H0
    DEF SEG
    IF X = 128 THEN
       Temp# = -1#
    END IF
    Last.Token = True
    IF InDEFSEG THEN
       DEF SEG = DEFSEGvalue
    ELSE
       DEF SEG
    END IF
 ' other functions
 CASE "PMAP"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number% = CINT(Temp#)
    CALL Get.Token
    CALL Parse1(Temp#)
    Map.Type% = CINT(Temp#)
    Temp# = PMAP(Number%, Map.Type%)
    CALL Get.Token4
    Last.Token = True
 CASE "VARSEG"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    IF Last.Token THEN
       Var.Seg2 = Temp#
       Temp# = VARSEG(Var.Seg2)
       IF Temp# < 0# THEN
          Temp# = Temp# + 65536#
       END IF
    ELSE
       Length = LEN(Out3)
       REDIM Var.Seg3(1 TO Length) AS INTEGER
       FOR Count = 1 TO Length
	  Var.Seg3(Count) = ASC(MID$(Out3, Count, 1))
       NEXT
       Temp# = VARSEG(Var.Seg3(1))
       IF Temp# < 0# THEN
          Temp# = Temp# + 65536#
       END IF
    END IF
    CALL Get.Token4
    Last.Token = True
 CASE "VARPTR$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    IF Last.Token THEN
       Var.Seg2 = Temp#
       Out3 = VARPTR$(Var.Seg2)
    ELSE
       Var.Seg1 = Out3
       Out3 = VARPTR$(Var.Seg1)
    END IF
    CALL Get.Token4
    Last.Token = False
 CASE "VARPTR"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    IF Last.Token THEN
       Var.Seg2 = Temp#
       Temp# = VARPTR(Var.Seg2)
       IF Temp# < 0# THEN
          Temp# = Temp# + 65536#
       END IF
    ELSE
       Length = LEN(Out3)
       REDIM Var.Seg3(1 TO Length) AS INTEGER
       FOR Count = 1 TO Length
	  Var.Seg3(Count) = ASC(MID$(Out3, Count, 1))
       NEXT
       Temp# = VARPTR(Var.Seg3(1))
       IF Temp# < 0# THEN
          Temp# = Temp# + 65536#
       END IF
    END IF
    CALL Get.Token4
    Last.Token = True
 CASE "BUFFER"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Case.Value = Temp#
    SELECT CASE Case.Value
    CASE 1
       Temp# = Var.Seg2
       Last.Token = True
    CASE 2
       Out3 = Nul
       Length = UBOUND(Var.Seg3)
       FOR Count = 1 TO Length
	  Out3 = Out3 + CHR$(Var.Seg3(Count))
       NEXT
       Last.Token = False
    CASE 3
       Elements = INT((Array.Size + 1) / 2)
       FOR Count = 1 TO Elements
	  Graphics.Screen(Count) = Var.Seg3(Count)
       NEXT
       Last.Token = True
    END SELECT
    CALL Get.Token4
 CASE "GRPHSEG"
    Elements = INT((Array.Size + 1) / 2)
    REDIM Var.Seg3(1 TO Elements) AS INTEGER
    FOR Count = 1 TO Elements
       Var.Seg3(Count) = Graphics.Screen(Count)
    NEXT
    Temp# = VARSEG(Var.Seg3(1))
    Last.Token = True
 CASE "GRPHPTR"
    Elements = INT((Array.Size + 1) / 2)
    REDIM Var.Seg3(1 TO Elements) AS INTEGER
    FOR Count = 1 TO Elements
       Var.Seg3(Count) = Graphics.Screen(Count)
    NEXT
    Temp# = VARPTR(Var.Seg3(1))
    Last.Token = True
 CASE "PLAY"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = PLAY(Temp#)
    CALL Get.Token4
    Last.Token = True
 ' more numeric functions
 CASE "ABS"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = ABS(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "ASC"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = ASC(Out3)
    CALL Get.Token4
    Last.Token = True
 CASE "EXP"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = EXP(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "FBN" ' calculate xth fibonachi value
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Fibo.A# = 1
    Fibo.B# = 1
    IF Temp# >= 1 THEN
       FOR Fibo.Number# = 1 TO Temp# - 1
          Fibo.Temp# = Fibo.B#
          Fibo.B# = Fibo.A# + Fibo.B#
          Fibo.A# = Fibo.Temp#
       NEXT
    END IF
    Temp# = Fibo.B#
    CALL Get.Token4
    Last.Token = True
 CASE "FCT"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Factorial# = 1
    Factorial.Count# = INT(Temp#)
    IF Factorial.Count# >= 1 THEN
       FOR Factorial.Count# = 1 TO Temp#
	  Factorial# = Factorial# * Factorial.Count#
       NEXT
    END IF
    Temp# = Factorial#
    CALL Get.Token4
    Last.Token = True
 CASE "FIX"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = FIX(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "INP"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = INP(CINT(Temp#))
    CALL Get.Token4
    Last.Token = True
 CASE "INSTR"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    IF Last.Token THEN
       Temp4# = Temp#
       CALL Get.Token
       CALL Parse1(Temp#)
       Stored.String$ = Out3
       CALL Get.Token
       CALL Parse1(Temp#)
       Temp# = INSTR(Temp4#, Stored.String$, Out3)
    ELSE
       Stored.String$ = Out3
       CALL Get.Token
       CALL Parse1(Temp#)
       Temp# = INSTR(Stored.String$, Out3)
    END IF
    CALL Get.Token4
    Last.Token = True
 CASE "FRE"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    IF Last.Token THEN
       value# = Temp#
       Temp# = FRE(value#)
    ELSE
       Temp# = FRE(Out3)
    END IF
    CALL Get.Token4
    Last.Token = True
 CASE "INT"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = INT(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "LEN"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = CDBL(LEN(Out3))
    CALL Get.Token4
    Last.Token = True
 CASE "LOG"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = LOG(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "GCM"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number1# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Number2# = Temp#
    ' find last factor which divides into both numbers
    Factor1# = 1
    Number3# = Number1#
    FOR Factor2# = 2 TO Number1#
       DO
          IF Number3# / Factor2# = Number3# \ Factor2# THEN
             IF Number2# / Factor2# = Number2# \ Factor2# THEN
                IF Factor2# > Factor1# THEN
                   Factor1# = Factor2#
                END IF
             END IF
             Number3# = Number3# / Factor2#
          ELSE
             EXIT DO
          END IF
       LOOP
    NEXT
    Temp# = Factor1#
    CALL Get.Token4
    Last.Token = True
 CASE "LCD"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number1# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Number2# = Temp#
    ' find first factor which divides into both numbers
    Factor1# = 0
    FOR Factor2# = 2 TO Number1#
       IF Number1# / Factor2# = Number1# \ Factor2# THEN
          IF Number2# / Factor2# = Number2# \ Factor2# THEN
             Factor1# = Factor2#
             EXIT FOR
          END IF
       END IF
    NEXT
    IF Factor1# = 0# THEN
       Factor1# = 1#
    END IF
    IF Factor1# = Number2# THEN
       Factor1# = 1#
    END IF
    Temp# = Factor1#
    CALL Get.Token4
    Last.Token = True
 CASE "ISEVEN"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = (Temp# MOD 2#) = 0#
    CALL Get.Token4
    Last.Token = True
 CASE "ISODD"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = (Temp# MOD 2#) = 1#
    CALL Get.Token4
    Last.Token = True
 CASE "ISPRM" ' calculate x is prime
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Prime# = INT(Temp#)
    Prime.Flag = True
    IF Prime# > 2# THEN
       FOR Loop.Count# = 2# TO INT(SQR(Prime#))
          IF Prime# / Loop.Count# = INT(Prime# / Loop.Count#) THEN
             Prime.Flag = False
             EXIT FOR
          END IF
       NEXT
    END IF
    IF Prime.Flag = False THEN
       Temp# = 0#
    ELSE
       Temp# = -1#
    END IF
    CALL Get.Token4
    Last.Token = True
 CASE "PRF" ' calculate nth perfect number
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Perfect# = INT(Temp#)
    SELECT CASE Perfect# ' x = 1,2,4,6,12,16,18,30
    CASE 1#
       X# = 1#
    CASE 2#
       X# = 2#
    CASE 3#
       X# = 4#
    CASE 4#
       X# = 6#
    CASE 5#
       X# = 12#
    CASE 6#
       X# = 16#
    CASE 7#
       X# = 18#
    CASE ELSE
       ERROR 131
    END SELECT
    ' equation for perfect number
    Temp# = 2 ^ X# * (2 ^ (X# + 1) - 1)
    CALL Get.Token4
    Last.Token = True
 CASE "PRM" ' calculate xth prime
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Prime.Number# = INT(Temp#)
    Prime# = 1
    IF Prime.Number# > False THEN
       Prime.Counter# = False
       T! = TIMER
       DO
          IF TIMER - T! >= 1! THEN
             X = CSRLIN
             Y = POS(0)
             CALL StatusLine
             COLOR Plain, Black
             LOCATE X, Y, 1
             PRINT "";
             T! = TIMER
          END IF
	  Prime# = Prime# + 1
	  Prime.Flag = False
          FOR Factor# = 2 TO INT(SQR(Prime#))
             IF Prime# / Factor# = INT(Prime# / Factor#) THEN
		Prime.Flag = True
		EXIT FOR
	     END IF
	  NEXT
	  IF Prime.Flag = False THEN
	     Prime.Counter# = Prime.Counter# + 1
	  END IF
	  IF Prime.Counter# = Prime.Number# THEN
	     EXIT DO
	  END IF
          If StdinEnabled=0 Then
          IF INKEY$ = CHR$(3) THEN
             PRINT
             COLOR Red, Black
             PRINT "*break*":SOUND 900,6
             SLEEP 1
             COLOR Yellow, Black
             EXIT DO
          END IF
          IF BreakIS THEN
             EXIT DO
          END IF
          Endif
       LOOP
    END IF
    Temp# = Prime#
    CALL Get.Token4
    Last.Token = True
 CASE "SGN"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = SGN(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "SQR"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    IF Temp# < 0# THEN
       ERROR 157
    ELSE
       Temp# = SQR(Temp#)
    END IF
    CALL Get.Token4
    Last.Token = True
 CASE "CBR"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = Temp# ^ (1# / 3#)
    CALL Get.Token4
    Last.Token = True
 CASE "NTH"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = Number# ^ (1# / Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "PWR"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = Number# ^ Temp#
    CALL Get.Token4
    Last.Token = True
 CASE "VAL"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = VAL(Out3)
    CALL Get.Token4
    Last.Token = True
 CASE "PEEK"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = PEEK(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "MKI$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = MKI$(Temp#)
    CALL Get.Token4
    Last.Token = False
 CASE "MKS$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = MKS$(Temp#)
    CALL Get.Token4
    Last.Token = False
 CASE "MKD$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = MKD$(Temp#)
    CALL Get.Token4
    Last.Token = False
 CASE "CVI"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = CVI(Out3)
    CALL Get.Token4
    Last.Token = True
 CASE "CVS"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = CVS(Out3)
    CALL Get.Token4
    Last.Token = True
 CASE "CVD"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = CVD(Out3)
    CALL Get.Token4
    Last.Token = True
 CASE "EOF"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp3#)
    Temp# = EOF(CINT(Temp3#))
    CALL Get.Token4
    Last.Token = True
 CASE "LOC"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp3#)
    Temp# = LOC(CINT(Temp3#))
    CALL Get.Token4
    Last.Token = True
 CASE "LOF"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp3#)
    Temp# = LOF(CINT(Temp3#))
    CALL Get.Token4
    Last.Token = True
 CASE "EOD" ' end-of-data
    Allow.Extra = 1
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp3#)
    CALL Get.Token4

    ' search for data statement
    X = 0
    FOR V = 1 To Last.Line
       V$ = Program(V)
       V$ = STRIM$(V$)
       V$ = UCASE$(V$)
       IF LEFT$(V$, 4) = "DATA" THEN
          X = -1
          EXIT FOR
       END IF
    NEXT
    IF X = 0 THEN
       Temp# = -1
       Out3 = "-1"
       Last.Token = True
       Allow.Extra = 0
       EXIT SUB
    END IF

    V1 = DataLine
    V2 = DataNumber
    Stored.Out2$ = Out2
    Stored.Token.Index = Token.Index
    CALL Read.Data.Element(More.Data)
    DataLine = V1
    DataNumber = V2
    Out2 = Stored.Out2$
    Token.Index = Stored.Token.Index
    Temp# = CDBL(More.Data)
    Out3 = Str$(More.Data)
    Last.Token = True
    Allow.Extra = 0
 CASE "TOD" ' type-of-data
    Allow.Extra = 1
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp3#)
    CALL Get.Token4

    ' search for data statement
    X = 0
    FOR V = 1 To Last.Line
       V$ = Program(V)
       V$ = STRIM$(V$)
       V$ = UCASE$(V$)
       IF LEFT$(V$, 4) = "DATA" THEN
          X = -1
          EXIT FOR
       END IF
    NEXT
    IF X = 0 THEN
       Temp# = 0
       Out3 = "0"
       Last.Token = True
       Allow.Extra = 0
       EXIT SUB
    END IF

    V1 = DataLine
    V2 = DataNumber
    Stored.Out2$ = Out2
    Stored.Token.Index = Token.Index
    CALL Read.Data.Element(More.Data)
    DataLine = V1
    DataNumber = V2
    Out2 = Stored.Out2$
    Token.Index = Stored.Token.Index

    ' store datatype of next data element
    IF More.Data = False THEN
       IF Last.Token THEN
          Temp# = 1# ' numeric
       ELSE
          Temp# = 2# ' string
       END IF
    ELSE
       Temp# = DFalse ' no more data
    END IF
    Last.Token = True
    Out3 = Str$(Temp#)
    Allow.Extra = 0
 CASE "ISDATA" ' is-type-of-data
    Allow.Extra = 1
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp3#)
    CALL Get.Token4
    SearchType = Temp3#

    ' search for data statement
    X = 0
    FOR V = 1 To Last.Line
       V$ = Program(V)
       V$ = STRIM$(V$)
       V$ = UCASE$(V$)
       IF LEFT$(V$, 4) = "DATA" THEN
          X = -1
          EXIT FOR
       END IF
    NEXT
    IF X = 0 THEN
       If SearchType = 0 Then
          Temp# = -1
          Out3 = "-1"
       Else
          Temp# = 0
          Out3 = "0"
       Endif
       Last.Token = True
       Allow.Extra = 0
       EXIT SUB
    END IF

    V1 = DataLine
    V2 = DataNumber
    Stored.Out2$ = Out2
    Stored.Token.Index = Token.Index
    CALL Read.Data.Element(More.Data)
    DataLine = V1
    DataNumber = V2
    Out2 = Stored.Out2$
    Token.Index = Stored.Token.Index

    ' store datatype of next data element
    Temp# = 0#
    Select Case SearchType
    Case 0 ' more data
       IF More.Data THEN
          Temp# = -1
       END IF
    Case 1 ' numeric
       IF More.Data = False THEN
          IF Last.Token THEN
             Temp# = -1 ' numeric
          END IF
       END IF
    Case 2 ' string
       IF More.Data = False THEN
          IF Last.Token = 0 THEN
             Temp# = -1 ' string
          END IF
       END IF
    End Select

    Last.Token = True
    Out3 = Str$(Temp#)
    Allow.Extra = 0
 ' disk functions
 CASE "CAPITALIZE"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    CALL Capitalize(Out3)
    CALL Get.Token4
    Last.Token = False
 CASE "SUFFIX"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    CALL Suffix(Temp#, Out3)
    CALL Get.Token4
    Last.Token = False
 CASE "FILEEXISTS"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    CALL GetBits(Var#)
    IF (Var# AND &H10) THen
       Temp# = 0
    ELSE
       Var$ = DIR$(Out3)
       IF Var$ = Nul THEN
          Temp# = 0
       ELSE
          Temp# = -1
       END IF
    END IF
    CALL Get.Token4
    Last.Token = True
 CASE "DIREXISTS"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    CALL GetBits(Var#)
    IF (Var# AND &H10) THen
       Temp# = -1
    ELSE
       Temp# = 0
    END IF
    CALL Get.Token4
    Last.Token = True
 CASE "DRIVEEXISTS"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Var# = Temp#
    Temp# = 0#
    IF Last.Token THEN
       Var = CINT(Var#)
       IF Var >= 1 AND Var <= 26 THEN
          CALL Check.Drive(Var, Temp#)
       END IF
    ELSE
       Var = ASC(UCASE$(Out3))
       IF Var >= 65 AND Var <= 90 THEN
          Var = Var - 64
          CALL Check.Drive(Var, Temp#)
       END IF
    END IF
    CALL Get.Token4
    Last.Token = True
 CASE "AMBIG$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Out3 = Ambiguate$(Out3)
    CALL Get.Token4
    Last.Token = False
 CASE "CONCAT$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Call Concatenate(Out3)
    CALL Get.Token4
    Last.Token = False
 CASE "CURDIR$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    IF Last.Token THEN
       Var = CINT(Temp#)
       IF Var >= 1 AND Var <= 26 THEN
          Out3 = CHR$(Var + 64)
       ELSE
          Out3 = Nul
       END IF
    ELSE
       Var$ = UCASE$(Out3)
       IF Var$ >= "A" AND Var$ <= "Z" THEN
          Out3 = Var$
       ELSE
          Out3 = Nul
       END IF
    END IF
    Out3 = CURDIR$(Out3)
    CALL Get.Token4
    Last.Token = False
 CASE "ENVIRON$"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    IF Last.Token THEN
       Var = CINT(Temp#)
       Out3 = ENVIRON$(Var)
    ELSE
       Out3 = ENVIRON$(Out3)
    END IF
    CALL Get.Token4
    Last.Token = False
 CASE "DIR$", "FILEDIR"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    CALL FileDir(Out3)
    CALL Get.Token4
    Last.Token = False
 CASE "DIRX$", "FILEDIRX"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    CALL FileDirX(Out3)
    CALL Get.Token4
    Last.Token = False
 CASE "FILES"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    CALL List.Files(Out3, True)
    CALL Get.Token4
    Last.Token = False
 CASE "DIRS"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    CALL List.Files(Out3, False)
    CALL Get.Token4
    Last.Token = False
 CASE "DRIVES"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Var = 0
    Var$ = Nul
    IF Last.Token THEN
       Var = CINT(Temp#)
       IF Var >= 0 AND Var <= 26 THEN
          CALL List.Drives("", Var)
          Temp# = -1#
       ELSE
          Temp# = 0#
       END IF
    ELSE
       Var$ = UCASE$(Out3)
       CALL List.Drives(Var$, 0)
       Temp# = -1#
    END IF
    CALL Get.Token4
    Last.Token = True
 CASE "FILESIZE"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = DFalse
    IF Last.Token THEN
       ERROR 53
    END IF
    IF LEN(Out3) = 0 THEN
       ERROR 53
    END IF
    IF Last.Token = False THEN
       IF LEN(Out3) THEN
	  Last.Token = True
          ASCIIZ = Out3 + CHR$(0)
	  ' restore directory search dta
	  InregsX.AX = &H1A00
          InregsX.DS = VARSEG(ParseDTA)
          InregsX.DX = VARPTR(ParseDTA)
	  CALL InterruptX(&H21, InregsX, OutregsX)
	  ' find first filename
	  InregsX.AX = &H4E00
	  InregsX.CX = &H27
          InregsX.DS = VARSEG(ASCIIZ)
          InregsX.DX = VARPTR(ASCIIZ)
	  CALL InterruptX(&H21, InregsX, OutregsX)
          Temp# = ASC(MID$(ParseDTA.FileSize, 4, 1))
          Temp# = Temp# * &H100 + ASC(MID$(ParseDTA.FileSize, 3, 1))
          Temp# = Temp# * &H100 + ASC(MID$(ParseDTA.FileSize, 2, 1))
          Temp# = Temp# * &H100 + ASC(MID$(ParseDta.FileSize, 1, 1))
          ' restore basic dta
          InregsX.AX = &H1A00
          InregsX.DS = BASIC.DTA.SEG
          InregsX.DX = BASIC.DTA.OFF
          CALL InterruptX(&H21, InregsX, OutregsX)
       END IF
    END IF
    CALL Get.Token4
 CASE "FILEATTR"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = DFalse
    IF Last.Token THEN
       ERROR 53
    END IF
    IF LEN(Out3) = 0 THEN
       ERROR 53
    END IF
    IF Last.Token = False THEN
       IF LEN(Out3) THEN
          CALL GetBits (Temp#)
          IF Temp# = -1# THEN
             ERROR 53
          END IF
	  Last.Token = True
       END IF
    END IF
    CALL Get.Token4
 CASE "FILEBITS"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = DFalse
    IF Last.Token THEN
       ERROR 53
    END IF
    IF LEN(Out3) = 0 THEN
       ERROR 53
    END IF
    IF Last.Token = False THEN
       IF LEN(Out3) THEN
          CALL GetBits (Temp#)
          IF Temp# = -1# THEN
             ERROR 53
          END IF
          Out3 = SPACE$(5)
          IF (Temp# AND &H20) = &H20 THEN
             MID$(Out3, 1, 1) = "A" ' archive
          END IF
          IF (Temp# AND &H10) = &H10 THEN
             MID$(Out3, 2, 1) = "D" ' directory
          END IF
          IF (Temp# AND &H4) = &H4 THEN
             MID$(Out3, 3, 1) = "S" ' system
          END IF
          IF (Temp# AND &H2) = &H2 THEN
             MID$(Out3, 4, 1) = "H" ' hidden
          END IF
          IF (Temp# AND &H1) = &H1 THEN
             MID$(Out3, 5, 1) = "R" ' read-only
          END IF
          Last.Token = False
       END IF
    END IF
    CALL Get.Token4
 CASE "FILEDATE"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = DFalse
    IF Last.Token THEN
       ERROR 53
    END IF
    IF LEN(Out3) = 0 THEN
       ERROR 53
    END IF
    IF Last.Token = False THEN
       IF LEN(Out3) THEN
          ASCIIZ = Out3 + CHR$(0)
	  ' restore directory search dta
	  InregsX.AX = &H1A00
          InregsX.DS = VARSEG(ParseDTA)
          InregsX.DX = VARPTR(ParseDTA)
	  CALL InterruptX(&H21, InregsX, OutregsX)
	  ' find first filename
	  InregsX.AX = &H4E00
          InregsX.CX = &H37
          InregsX.DS = VARSEG(ASCIIZ)
          InregsX.DX = VARPTR(ASCIIZ)
	  CALL InterruptX(&H21, InregsX, OutregsX)
	  ' check findfirst error
          IF (OutregsX.Flags AND &H1) = &H1 THEN
             ' restore basic dta
             InregsX.AX = &H1A00
             InregsX.DS = BASIC.DTA.SEG
             InregsX.DX = BASIC.DTA.OFF
             CALL InterruptX(&H21, InregsX, OutregsX)
             ERROR 53
          END IF
	  ' check findfirst error
	  IF (OutregsX.Flags AND &H1) = &H0 THEN
	     ' store file date
             Work! = ASC(MID$(ParseDTA.FileDate, 2, 1))
             Work! = Work! * &H100 + ASC(MID$(ParseDTA.FileDate, 1, 1))
             YearTemp! = INT(Work! / 512)
             MonthTemp! = INT((Work! AND &H1E0) / 32)
             DayTemp! = INT(Work! AND &H1F)
             YearTemp! = YearTemp! + 1980
             Out3 = RIGHT$(STR$(MonthTemp! + 100), 2) + "-" + RIGHT$(STR$(DayTemp! + 100), 2) + "-" + MID$(STR$(YearTemp!), 2)
	  END IF
	  ' restore basic dta
	  InregsX.AX = &H1A00
	  InregsX.DS = BASIC.DTA.SEG
	  InregsX.DX = BASIC.DTA.OFF
	  CALL InterruptX(&H21, InregsX, OutregsX)
       END IF
    END IF
    CALL Get.Token4
 CASE "FILETIME"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = DFalse
    IF Last.Token THEN
       ERROR 53
    END IF
    IF LEN(Out3) = 0 THEN
       ERROR 53
    END IF
    IF Last.Token = False THEN
       IF LEN(Out3) THEN
          ASCIIZ = Out3 + CHR$(0)
	  ' restore directory search dta
	  InregsX.AX = &H1A00
          InregsX.DS = VARSEG(ParseDTA)
          InregsX.DX = VARPTR(ParseDTA)
	  CALL InterruptX(&H21, InregsX, OutregsX)
	  ' find first filename
	  InregsX.AX = &H4E00
          InregsX.CX = &H37
          InregsX.DS = VARSEG(ASCIIZ)
          InregsX.DX = VARPTR(ASCIIZ)
	  CALL InterruptX(&H21, InregsX, OutregsX)
	  ' check findfirst error
          IF (OutregsX.Flags AND &H1) = &H1 THEN
             ' restore basic dta
             InregsX.AX = &H1A00
             InregsX.DS = BASIC.DTA.SEG
             InregsX.DX = BASIC.DTA.OFF
             CALL InterruptX(&H21, InregsX, OutregsX)
             ERROR 53
          END IF
	  ' check findfirst error
	  IF (OutregsX.Flags AND &H1) = &H0 THEN
             Work! = ASC(MID$(ParseDTA.FileTime, 2, 1))
             Work! = Work! * &H100 + ASC(MID$(ParseDTA.FileTime, 1, 1))
             HourTemp! = INT(Work! / 2048)
             MinuteTemp! = INT((Work! AND &H7E0) / 32)
             SecondsTemp! = INT((Work! AND &H1F) / 2)
             Out3 = RIGHT$(STR$(HourTemp! + 100), 2) + ":" + RIGHT$(STR$(MinuteTemp! + 100), 2) + ":" + RIGHT$(STR$(SecondsTemp! + 100), 2)
	  END IF
	  ' restore basic dta
	  InregsX.AX = &H1A00
	  InregsX.DS = BASIC.DTA.SEG
	  InregsX.DX = BASIC.DTA.OFF
	  CALL InterruptX(&H21, InregsX, OutregsX)
       END IF
    END IF
    CALL Get.Token4
 CASE "VLABEL"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    IF Last.Token THEN
       Drive.Number% = CINT(Temp#)
    ELSE
       Drive.Number% = CINT(ASC(UCASE$(Out3)) - 64)
    END IF
    Call Vlabel(Drive.Number%)
    Last.Token = False
    CALL Get.Token4
 CASE "VSERIAL"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    IF Last.Token THEN
       Drive.Number% = CINT(Temp#)
    ELSE
       Drive.Number% = CINT(ASC(UCASE$(Out3)) - 64)
    END IF
    Call Vserial(Drive.Number%)
    Last.Token = False
    CALL Get.Token4
 CASE "VTYPE"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    IF Last.Token THEN
       Drive.Number% = CINT(Temp#)
    ELSE
       Drive.Number% = CINT(ASC(UCASE$(Out3)) - 64)
    END IF
    Call Vtype(Drive.Number%)
    Last.Token = False
    CALL Get.Token4
 CASE "DRV"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    IF Last.Token THEN
       Var = CINT(Temp#)
       IF Var >= 1 AND Var <= 26 THEN
          Out3 = CHR$(Var + 64)
       ELSE
          Out3 = Nul
       END IF
    ELSE
       Var$ = UCASE$(Out3)
       IF Var$ >= "A" AND Var$ <= "Z" THEN
          Out3 = Var$
       ELSE
          Out3 = Nul
       END IF
    END IF
    IF LEN(Out3) THEN
       CALL FreeSpace(Out3)
       Temp# = INT(VAL(Out3)+.5)
    END IF
    Last.Token = True
    CALL Get.Token4
 CASE "TDRV"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    IF Last.Token THEN
       Var = CINT(Temp#)
       IF Var >= 1 AND Var <= 26 THEN
          Out3 = CHR$(Var + 64)
       ELSE
          Out3 = Nul
       END IF
    ELSE
       Var$ = UCASE$(Out3)
       IF Var$ >= "A" AND Var$ <= "Z" THEN
          Out3 = Var$
       ELSE
          Out3 = Nul
       END IF
    END IF
    IF LEN(Out3) THEN
       CALL TotalSpace(Out3)
       Temp# = INT(VAL(Out3)+.5)
    END IF
    Last.Token = True
    CALL Get.Token4
 CASE "TEMPFILENAME"
    Out3 = TempName$
    Last.Token = False
 ' bubble sort variable array ascending
 CASE "SORT"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    CALL Get.Token4
    Var = CINT(Temp#)
    IF Var>=1 AND Var<=26 THEN
       FOR Var1=1 TO Max.Arrays
          FOR Var2=Var1+1 TO Max.Arrays
             IF Arrays(Var, Var1)>Arrays(Var, Var2) Then
                SWAP Arrays(Var, Var1), Arrays(Var, Var2)
             END IF
          NEXT
       NEXT
       Last.Token = True
       EXIT SUB
    END IF
    ERROR 2
 ' bubble sort variable array descending
 CASE "ZSORT"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    CALL Get.Token4
    Var = CINT(Temp#)
    IF Var>=1 AND Var<=26 THEN
       FOR Var1=1 TO Max.Arrays
          FOR Var2=Var1+1 TO Max.Arrays
             IF Arrays(Var, Var1)<Arrays(Var, Var2) Then
                SWAP Arrays(Var, Var1), Arrays(Var, Var2)
             END IF
          NEXT
       NEXT
       Last.Token = True
       EXIT SUB
    END IF
    ERROR 2
 ' bubble sort variables
 CASE "ZSORT2"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    CALL Get.Token4
    Var = CINT(Temp#)
    IF Var=0 THEN
       ' ascending
       FOR Var1=1 TO 26
          FOR Var2=Var1+1 TO 26
             IF Variables(Var1)>Variables(Var2) Then
                SWAP Variables(Var1), Variables(Var2)
             END IF
          NEXT
       NEXT
    ELSE
       ' descending
       FOR Var1=1 TO 26
          FOR Var2=Var1+1 TO 26
             IF Variables(Var1)<Variables(Var2) Then
                SWAP Variables(Var1), Variables(Var2)
             END IF
          NEXT
       NEXT
    END IF
    Temp#=-1
    Last.Token = True
    EXIT SUB
 ' fill array with random values
 CASE "RNDARRAY"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Var = CINT(Temp#)
    CALL Get.Token
    CALL Parse1(Temp#)
    VarX# = Temp#
    CALL Get.Token4
    IF Var>=1 AND Var<=26 THEN
       FOR Var2=1 To Max.Arrays
          Arrays(Var, Var2) = INT(RND*VarX#+1)
       NEXT
       Temp# = Var
       Last.Token = True
       EXIT SUB
    END IF
    ERROR 2
 ' fill variables with random values
 CASE "RNDARRAY2"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    CALL Get.Token4
    FOR Var1=1 To 26
       Variables(Var1) = INT(RND*Temp#+1)
    NEXT
    Temp# = -1
    Last.Token = True
    EXIT SUB
 ' get array value
 CASE "ARRAY"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Var1 = CINT(Temp#)
    CALL Get.Token
    CALL Parse1(Temp#)
    Var2 = CINT(Temp#)
    CALL Get.Token4
    IF Var1>=1 AND Var1<=26 THEN
       IF Var2>=1 AND Var2<=Max.Arrays THEN
          Temp# = Arrays(Var1, Var2)
          Last.Token = True
          EXIT SUB
       END IF
    END IF
    ERROR 2
 ' set array value
 CASE "SETARRAY"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Var1 = CINT(Temp#)
    CALL Get.Token
    CALL Parse1(Temp#)
    Var2 = CINT(Temp#)
    CALL Get.Token
    CALL Parse1(Temp#)
    VarX# = Temp#
    CALL Get.Token4
    IF Var1>=1 AND Var1<=26 THEN
       IF Var2>=1 AND Var2<=Max.Arrays THEN
          Arrays(Var1, Var2) = VarX#
          Temp# = Var1
          Last.Token = True
          EXIT SUB
       END IF
    END IF
    ERROR 2
 ' get variable value
 CASE "VARIABLE"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Var1 = CINT(Temp#)
    CALL Get.Token4
    IF Var1>=1 AND Var1<=26 THEN
       Temp# = Variables(Var1)
       Last.Token = True
       EXIT SUB
    END IF
    ERROR 2
 ' set variable value
 CASE "SETVARIABLE"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Var1 = CINT(Temp#)
    CALL Get.Token
    CALL Parse1(Temp#)
    VarX# = Temp#
    CALL Get.Token4
    IF Var1>=1 AND Var1<=26 THEN
       Variables(Var1) = VarX#
       Temp# = Var1
       Last.Token = True
       EXIT SUB
    END IF
    ERROR 2

 REM Basic internal trigonometric functions..

 CASE "ATN"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = ATN(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "COS"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = COS(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "COT"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = COS(Temp#) / SIN(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "CSC"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = 1# / SIN(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "SEC"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = 1# / COS(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "SIN"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = SIN(Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE "TAN"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = TAN(Temp#)
    CALL Get.Token4
    Last.Token = True

 REM Remaining nonintrinsic trigonometric functions..

 'Inverse Cosine
 CASE "ARCCOS"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = ATN(-Temp# / SQR(-Temp# * Temp# + 1#)) + 2# * ATN(1#)
    CALL Get.Token4
    Last.Token = True
 'Inverse Cosecant
 CASE "ARCCOSEC"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = ATN(Temp# / SQR(Temp# * Temp# - 1#)) + (SGN(Temp#) - 1#) * (2# * ATN(1#))
    CALL Get.Token4
    Last.Token = True
 'Inverse Cotangent
 CASE "ARCCOTAN"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = ATN(Temp#) + 2# * ATN(1#)
    CALL Get.Token4
    Last.Token = True
 'Inverse Secant
 CASE "ARCSEC"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = ATN(Temp# / SQR(Temp# * Temp# - 1#)) + SGN((Temp#) - 1#) * (2# * ATN(1#))
    CALL Get.Token4
    Last.Token = True
 'Inverse Sine
 CASE "ARCSIN"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = ATN(Temp# / SQR(-Temp# * Temp# + 1#))
    CALL Get.Token4
    Last.Token = True
 'Inverse Hyperbolic Cosine
 CASE "HARCCOS"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = LOG(Temp# + SQR(Temp# * Temp# - 1#))
    CALL Get.Token4
    Last.Token = True
 'Inverse Hyperbolic Cosecant
 CASE "HARCCOSEC"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = LOG((SGN(Temp#) * SQR(Temp# * Temp# + 1#) + 1#) / Temp#)
    CALL Get.Token4
    Last.Token = True
 'Inverse Hyperbolic Cotangent
 CASE "HARCCOTAN"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = LOG((Temp# + 1#) / (Temp# - 1#)) / 2#
    CALL Get.Token4
    Last.Token = True
 'Inverse Hyperbolic Secant
 CASE "HARCSEC"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = LOG((SQR(-Temp# * Temp# + 1#) + 1#) / Temp#)
    CALL Get.Token4
    Last.Token = True
 'Inverse Hyperbolic Sine
 CASE "HARCSIN"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = LOG(Temp# + SQR(Temp# * Temp# + 1#))
    CALL Get.Token4
    Last.Token = True
 'Inverse Hyperbolic Tangent
 CASE "HARCTAN"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = LOG((1# + Temp#) / (1# - Temp#)) / 2#
    CALL Get.Token4
    Last.Token = True
 'Hyperbolic Cosine
 CASE "HCOS"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = (EXP(Temp#) + EXP(-Temp#)) / 2#
    CALL Get.Token4
    Last.Token = True
 'Hyperbolic Cosecant
 CASE "HCOSEC"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = 2# / (EXP(Temp#) - EXP(-Temp#))
    CALL Get.Token4
    Last.Token = True
 'Hyperbolic Cotangent
 CASE "HCOTAN"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = (EXP(Temp#) + EXP(-Temp#)) / (EXP(Temp#) - EXP(-Temp#))
    CALL Get.Token4
    Last.Token = True
 'Hyperbolic Secant
 CASE "HSEC"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = 2# / (EXP(Temp#) + EXP(-Temp#))
    CALL Get.Token4
    Last.Token = True
 'Hyperbolic Sine
 CASE "HSIN"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = (EXP(Temp#) - EXP(-Temp#)) / 2#
    CALL Get.Token4
    Last.Token = True
 'Hyperbolic Tangent
 CASE "HTAN"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = (EXP(Temp#) - EXP(-Temp#)) / (EXP(Temp#) + EXP(-Temp#))
    CALL Get.Token4
    Last.Token = True
 'Convert Degrees to Radians
 CASE "DEGTORAD"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = ((ATN(1#) * 4#) / 180#) * Temp#
    CALL Get.Token4
    Last.Token = True
 'Convert Radians to Degrees
 CASE "RADTODEG"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = (180# / (ATN(1#) * 4#)) * Temp#
    CALL Get.Token4
    Last.Token = True
 ' Hypotenuse
 CASE "HYPOT"
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp#)
    Number# = Temp#
    CALL Get.Token
    CALL Parse1(Temp#)
    Temp# = SQR(Number# * Number# + Temp# * Temp#)
    CALL Get.Token4
    Last.Token = True
 CASE ELSE
    IF Allow.Alpha THEN
       Out3 = Strng
    ELSE
       Strng = "{" + Strng + "}"
       ERROR 92
    END IF
 END SELECT
END SUB

SUB Check.Drive(V, T#)
 ON LOCAL ERROR GOTO Disk.Error
 ' check disk space.
 InregsX.AX = &H3600
 InregsX.DX = V
 CALL InterruptX(&H21, InregsX, OutregsX)
 IF OutregsX.AX = &HFFFF THEN
    T# = 0#
 ELSE
    T# = -1#
 END IF
 EXIT SUB
Disk.Error:
 T# = 0#
 EXIT SUB
END SUB

Sub Vlabel(V%)
 Out3 = Nul
 IF V >= 1 AND V <= 26 THEN
    CALL Check.Drive(V, Temp#)
 END IF
 IF Temp# = 0# THEN
    ERROR 166
    EXIT SUB
 END IF
 ASCIIZ = CHR$(V% + 64) + ":\*.*" + CHR$(0)
 ' restore directory search dta
 InregsX.AX = &H1A00
 InregsX.DS = VARSEG(ParseDTA)
 InregsX.DX = VARPTR(ParseDTA)
 CALL InterruptX(&H21, InregsX, OutregsX)
 ' find volume label
 InregsX.AX = &H4E00
 InregsX.CX = &H8
 InregsX.DS = VARSEG(ASCIIZ)
 InregsX.DX = VARPTR(ASCIIZ)
 CALL InterruptX(&H21, InregsX, OutregsX)
 ' check findfirst error
 IF (OutregsX.Flags AND &H1) = &H0 THEN
    Out3 = ParseDTA.ASCIIZfilename
    IF INSTR(Out3, CHR$(0)) THEN
       Out3 = LEFT$(Out3, INSTR(Out3, CHR$(0)) - 1)
    END IF
 END IF
 ' restore basic dta
 InregsX.AX = &H1A00
 InregsX.DS = BASIC.DTA.SEG
 InregsX.DX = BASIC.DTA.OFF
 CALL InterruptX(&H21, InregsX, OutregsX)
End Sub

Sub Vserial(V%)
 Out3 = Nul
 IF V >= 1 AND V <= 26 THEN
    CALL Check.Drive(V, Temp#)
 END IF
 IF Temp# = 0# THEN
    ERROR 166
    EXIT SUB
 END IF
 ' get volume info
 InregsX.AX = &H6900
 InregsX.BX = V%
 InregsX.DS = VARSEG(BPBfile)
 InregsX.DX = VARPTR(BPBfile)
 CALL InterruptX(&H21, InregsX, OutregsX)
 ' check flag error
 IF (OutregsX.Flags AND &H1) = &H0 THEN
    ' store volume serial number
    FOR Serial.Digit = 4 TO 1 STEP -1
       IF Serial.Digit = 2 THEN
          Out3 = Out3 + "-"
       END IF
       Serial.Value = ASC(MID$(BPBfile.Serial, Serial.Digit, 1))
       Out3 = Out3 + RIGHT$(HEX$(Serial.Value + &H100), 2)
    NEXT
 END IF
End Sub

SUB Vtype (V%)
 Out3 = ""
 IF V >= 1 AND V <= 26 THEN
    CALL Check.Drive(V, Temp#)
 END IF
 IF Temp# = 0# THEN
    EXIT SUB
 END IF
 ' get volume info
 InregsX.AX = &H6900
 InregsX.BX = Drive.Number%
 InregsX.DS = VARSEG(BPBfile)
 InregsX.DX = VARPTR(BPBfile)
 CALL InterruptX(&H21, InregsX, OutregsX)
 ' check flag error
 IF (OutregsX.Flags AND &H1) = &H0 THEN
    ' store volume file system type
    Out3 = RTRIM$(BPBfile.System)
 END IF
END SUB

' process a number
SUB Parse.Numeric (Temp#)
 SELECT CASE RIGHT$(UCASE$(Strng), 1) ' compare character after number
 CASE "Q" ' perfect number suffix
    FOR Digit = 1 TO LEN(Strng) - 1
       OutX$ = UCASE$(MID$(Strng, Digit, 1))
       SELECT CASE OutX$
       CASE "0" TO "9"
          ' nul
       CASE ELSE
          ERROR 131
       END SELECT
    NEXT
    Temp# = CDBL(VAL(LEFT$(Strng, LEN(Strng) - 1)))
    Perfect# = INT(Temp#)
    SELECT CASE Perfect# ' x = 1,2,4,6,12,16,18,30
    CASE 1#
       X# = 1#
    CASE 2#
       X# = 2#
    CASE 3#
       X# = 4#
    CASE 4#
       X# = 6#
    CASE 5#
       X# = 12#
    CASE 6#
       X# = 16#
    CASE 7#
       X# = 18#
    CASE ELSE
       ERROR 131
    END SELECT
    ' equation for perfect number
    Temp# = 2 ^ X# * (2 ^ (X# + 1) - 1)
 CASE "P" ' prime number suffix
    FOR Digit = 1 TO LEN(Strng) - 1
       OutX$ = UCASE$(MID$(Strng, Digit, 1))
       SELECT CASE OutX$
       CASE "0" TO "9"
          ' nul
       CASE ELSE
          ERROR 131
       END SELECT
    NEXT
    Temp# = CDBL(VAL(LEFT$(Strng, LEN(Strng) - 1)))
    Prime.Number# = INT(Temp#)
    Prime# = 1
    IF Prime.Number# > False THEN
       Prime.Counter# = False
       T! = TIMER
       DO
          IF TIMER - T! >= 1! THEN
             X = CSRLIN
             Y = POS(0)
             CALL StatusLine
             COLOR Plain, Black
             LOCATE X, Y, 1
             PRINT "";
             T! = TIMER
          END IF
	  Prime# = Prime# + 1
	  Prime.Flag = False
          FOR Factor# = 2 TO INT(SQR(Prime#))
             IF Prime# / Factor# = INT(Prime# / Factor#) THEN
		Prime.Flag = True
		EXIT FOR
	     END IF
	  NEXT
	  IF Prime.Flag = False THEN
	     Prime.Counter# = Prime.Counter# + 1
	  END IF
	  IF Prime.Counter# = Prime.Number# THEN
	     EXIT DO
	  END IF
          If StdinEnabled=0 Then
          IF INKEY$ = CHR$(3) THEN
             PRINT
             COLOR Red, Black
             PRINT "*break*":SOUND 900,6
             SLEEP 1
             COLOR Yellow, Black
             EXIT DO
          END IF
          IF BreakIS THEN
             EXIT DO
          END IF
          Endif
       LOOP
    END IF
    Temp# = Prime#
 CASE "F" ' factorial
    Temp2 = False
    Temp3 = LEN(Strng)
    DO
       IF UCASE$(MID$(Strng, Temp3, 1)) <> "F" THEN
	  EXIT DO
       END IF
       Temp2 = Temp2 + 1
       Temp3 = Temp3 - 1
    LOOP
    FOR Decimal.Digit = 1 TO Temp3
       OutX$ = UCASE$(MID$(Strng, Decimal.Digit, 1))
       SELECT CASE OutX$
       CASE "0" TO "9"
          ' nul
       CASE ELSE
          ERROR 132
       END SELECT
    NEXT
    Temp4# = VAL(LEFT$(Strng, Temp3))
    FOR Number = 1 TO Temp2
       Temp# = 1#
       FOR Factorial# = 2# TO Temp4#
	  Temp# = Temp# * Factorial#
       NEXT
       Temp4# = Temp#
    NEXT
 CASE "H" ' hexidecimal suffix
    Temp# = False
    Hex.Power = False
    FOR Hex.Digit = LEN(Strng) - 1 TO 1 STEP -1
       OutX$ = UCASE$(MID$(Strng, Hex.Digit, 1))
       SELECT CASE OutX$
       CASE "0" TO "9", "A" TO "F"
          Hex.Value = VAL("&H" + OutX$)
          Temp# = Temp# + Hex.Value * 16 ^ Hex.Power
          Hex.Power = Hex.Power + 1
       CASE ELSE
          ERROR 127
       END SELECT
    NEXT
 CASE "O" ' octal suffix
    Temp# = False
    Octal.Power = False
    FOR Octal.Digit = LEN(Strng) - 1 TO 1 STEP -1
       OutX$ = MID$(Strng, Octal.Digit, 1)
       IF OutX$ >= "0" AND OutX$ <= "7" THEN
          Octal.Value = VAL(OutX$)
          Temp# = Temp# + Octal.Value * 8 ^ Octal.Power
          Octal.Power = Octal.Power + 1
       ELSE
          ERROR 128
       END IF
    NEXT
 CASE "B" ' binary suffix
    Temp# = False
    Binary.Power = False
    FOR Binary.Digit = LEN(Strng) - 1 TO 1 STEP -1
       OutX$ = MID$(Strng, Binary.Digit, 1)
       SELECT CASE OutX$
       CASE "0"
          ' nul
       CASE "1"
	  Temp# = Temp# + 2 ^ Binary.Power
       CASE ELSE
          ERROR 129
       END SELECT
       Binary.Power = Binary.Power + 1
    NEXT
 CASE "0" TO "9", "D", "E" ' decimal/exponent suffix
    Decimal = False
    Exponent = False
    Number$ = Strng
 Start.Token:
    FOR Decimal.Digit = 1 TO LEN(Number$)
       OutX$ = UCASE$(MID$(Number$, Decimal.Digit, 1))
       SELECT CASE OutX$
       CASE "0" TO "9", "-", "+"
          ' nul
       CASE "D", "E"
          IF Exponent THEN
             ERROR 140
          END IF
          Exponent = True
          Exponent$ = UCASE$(RIGHT$(Number$, 1))
          IF Exponent$ = "D" OR Exponent$ = "E" THEN
             IF MID$(Out2, Token.Index, 1) = " " THEN
                Token.Index = Token.Index + 1
             END IF
             ' concatenate pre-parsed tokens into exponent
             Unary$ = MID$(Out2, Token.Index, 1)
             IF Unary$ = "+" OR Unary$ = "-" THEN
                Var$ = LEFT$(Out2, Token.Index - 1)
                CALL Get.Token
                VarX$ = Var$ + Strng
                IF INSTR(VarX$, "--") THEN
                   ERROR 142
                END IF
                IF INSTR(VarX$, "++") THEN
                   ERROR 142
                END IF
                Out2 = Var$ + Strng + MID$(Out2, Token.Index)
                CALL Get.Token
                IF Strng = Nul THEN
                   ERROR 141
                END IF
                IF Strng = "-" OR Strng = "+" THEN
                   ERROR 142
                END IF
                Number$ = Number$ + Unary$ + Strng
                IF INSTR(Strng, ".") THEN
                   ERROR 143
                END IF
                ' remove pre-parsed leading unary signs 
                DO
                   IF LEFT$(Number$, 1) = "-" THEN
                      Number$ = MID$(Number$, 2)
                   ELSE
                      IF LEFT$(Number$, 1) = "+" THEN
                         Number$ = MID$(Number$, 2)
                      ELSE
                         EXIT DO
                      END IF
                   END IF
                LOOP
                Decimal = False
                Exponent = False
                GOTO Start.Token
             ELSE
                ERROR 142
             END IF
          END IF
       CASE "."
          IF Exponent THEN
             ERROR 143
          END IF
          IF Decimal THEN
             ERROR 143
          END IF
          Decimal = True
       CASE ELSE
          ERROR 130
       END SELECT
    NEXT
    Temp# = CDBL(VAL(Number$))
 CASE ELSE
    ERROR 131
 END SELECT
 CALL Get.Token
 Last.Token = True
END SUB

' parse string in quotes
SUB Parse.Quoted
 Out3 = Nul
 DO UNTIL MID$(Out2, Token.Index, 1) = Quote
    Out3 = Out3 + MID$(Out2, Token.Index, 1)
    Token.Index = Token.Index + 1
    IF Token.Index > LEN(Out2) THEN
       ERROR 133
       EXIT DO
    END IF
 LOOP
 CALL Get.Token
 CALL Get.Token
 Last.Token = False
END SUB

' logical parser
SUB Parse1 (Temp#)
 CALL Parse2(Temp#) ' get next operator precedence
 Token.Parsed$ = Strng ' store token
 ' process token
 DO
    SELECT CASE Token.Parsed$
    CASE "|", "&", "~", "?", ":", "#", "@", "`"
       ' Nul
    CASE ELSE
       EXIT DO
    END SELECT
    Token.Stored$ = Out3
    CALL Get.Token ' read next token
    CALL Parse2(Temp2#) ' get next operator
    Out4 = Out3 ' reset current string
    Out3 = Token.Stored$ ' restore previous string
    CALL Arith(Token.Parsed$, Temp#, Temp2#) ' calculate expression
    Token.Parsed$ = Strng ' store next token
 LOOP
END SUB

' relational parser
SUB Parse2 (Temp#)
 CALL Parse3(Temp#) ' get next operator precedence
 Token.Parsed$ = Strng ' store token
 ' process token
 DO
    SELECT CASE Token.Parsed$
    CASE "<", ">", "=", ">=", "<=", "<>", "=="
       ' Nul
    CASE ELSE
       EXIT DO
    END SELECT
    Token.Stored$ = Out3 ' store current string
    CALL Get.Token ' read next token
    CALL Parse3(Temp2#) ' get next operator
    Out4 = Out3 ' reset current string
    Out3 = Token.Stored$ ' restore previous string
    CALL Arith(Token.Parsed$, Temp#, Temp2#) ' calculate expression
    Token.Parsed$ = Strng ' store next token
 LOOP
END SUB

' addition/subtraction parser
SUB Parse3 (Temp#)
 CALL Parse4(Temp#) ' get next operator precedence
 Token.Parsed$ = Strng ' store token
 ' process token
 DO
    SELECT CASE Token.Parsed$
    CASE "+", "-"
       ' Nul
    CASE ELSE
       EXIT DO
    END SELECT
    Token.Stored$ = Out3
    CALL Get.Token ' read next token
    CALL Parse4(Temp2#) ' get next operator
    Out4 = Out3
    Out3 = Token.Stored$
    CALL Arith(Token.Parsed$, Temp#, Temp2#) ' calculate expression
    Token.Parsed$ = Strng ' store next token
 LOOP
END SUB

' modulo parser
SUB Parse4 (Temp#)
 CALL Parse5(Temp#) ' get next operator precedence
 Token.Parsed$ = Strng ' store token
 ' process token
 DO
    SELECT CASE Token.Parsed$
    CASE "%"
       ' Nul
    CASE ELSE
       EXIT DO
    END SELECT
    Token.Stored$ = Out3
    CALL Get.Token ' read next token
    CALL Parse5(Temp2#) ' get next operator
    Out4 = Out3
    Out3 = Token.Stored$
    CALL Arith(Token.Parsed$, Temp#, Temp2#) ' calculate expression
    Token.Parsed$ = Strng ' store next token
 LOOP
END SUB

' integer division parser
SUB Parse5 (Temp#)
 CALL Parse6(Temp#) ' get next operator precedence
 Token.Parsed$ = Strng ' store token
 ' process token
 DO
    SELECT CASE Token.Parsed$
    CASE "\"
       ' Nul
    CASE ELSE
       EXIT DO
    END SELECT
    Token.Stored$ = Out3
    CALL Get.Token ' read next token
    CALL Parse6(Temp2#) ' get next operator
    Out4 = Out3
    Out3 = Token.Stored$
    CALL Arith(Token.Parsed$, Temp#, Temp2#) ' calculate expression
    Token.Parsed$ = Strng ' store next token
 LOOP
END SUB

' multiplication/division parser
SUB Parse6 (Temp#)
 CALL Parse7(Temp#) ' get next operator precedence
 Token.Parsed$ = Strng ' store token
 ' process token
 DO
    SELECT CASE Token.Parsed$
    CASE "*", "/"
       ' Nul
    CASE ELSE
       EXIT DO
    END SELECT
    Token.Stored$ = Out3
    CALL Get.Token ' read next token
    CALL Parse7(Temp2#) ' get next operator
    Out4 = Out3
    Out3 = Token.Stored$
    CALL Arith(Token.Parsed$, Temp#, Temp2#) ' calculate expression
    Token.Parsed$ = Strng ' store next token
 LOOP
END SUB

' power parser
SUB Parse7 (Temp#)
 CALL Parse7a(Temp#) ' get next operator precedence
 Token.Parsed$ = Strng ' store token
 ' process token
 DO
    SELECT CASE Token.Parsed$
    CASE "^"
       ' Nul
    CASE ELSE
       EXIT DO
    END SELECT
    Token.Stored$ = Out3
    CALL Get.Token ' read next token
    CALL Parse7a(Temp2#) ' get next operator
    Out4 = Out3
    Out3 = Token.Stored$
    CALL Arith(Token.Parsed$, Temp#, Temp2#) ' calculate expression
    Token.Parsed$ = Strng ' store next token
 LOOP
END SUB

 ' dual-unary parser
SUB Parse7a (Temp#)
 CALL Parse8(Temp#) ' get next operator precedence
 Token.Parsed$ = Strng ' store token
 ' process token
 DO
    SELECT CASE Token.Parsed$
    CASE "<<", ">>", "--", "++", "**", "//", "||", "##", "^^"
       ' Nul
    CASE ELSE
       EXIT DO
    END SELECT
    Token.Stored$ = Out3 ' store current token
    CALL Get.Token ' read next token
'    CALL Parse8(Temp2#) ' get next operator
    Out4 = Out3 ' reset current string
    Out3 = Token.Stored$ ' restore previous string
    CALL Arith(Token.Parsed$, Temp#, Temp2#) ' calculate expression
    Token.Parsed$ = Strng ' store next token
 LOOP
END SUB

' not/unary plus/unary negative parser
SUB Parse8 (Temp#)
 Token.Negate$ = Nul ' reset token storage
 Token.Parsed$ = Strng ' store token
 ' process token
 DO
    SELECT CASE Token.Parsed$
    CASE "!", "-", "+", "--", "++"
       ' Nul
    CASE ELSE
       EXIT DO
    END SELECT
    CALL Get.Token ' read next token
    Token.Negate$ = Token.Negate$ + Token.Parsed$
    Token.Parsed$ = Strng ' store token
 LOOP
 CALL Parse9(Temp#) ' get next operator
 ' process the combined operators in reverse
 FOR Token.Type = LEN(Token.Negate$) TO 1 STEP -1
    SELECT CASE MID$(Token.Negate$, Token.Type, 1) ' get previous token
    CASE "+"
       ' nul calculation for unary plus
    CASE "-"
       Temp# = -Temp# ' perform negate
    CASE "!" ' not
       Temp# = NOT Temp# ' perform not calculation
    END SELECT
 NEXT
END SUB

' string/numeric expression parser,
' routine returns calculated expression string/value,
' calls Parse1 recursively for values inside parenthesis/functions.
SUB Parse9 (Temp#)
 SELECT CASE Token ' determine token type
 CASE 0 ' no terminating token
    IF Last.Token = 3 THEN
       IF Allow.Extra = False THEN
          Strng = "<extra token>"
          ERROR 92
       END IF
    ELSE
       IF Strng = Nul THEN
          Strng = "<missing token>"
       ELSE
          Strng = "<" + Strng + ">"
       END IF
       ERROR 92
    END IF
    Last.Token = False
 CASE 1 ' token is symbol
    Token.Parsed$ = Strng
    SELECT CASE Token.Parsed$
    CASE ",", ";" ' separaters
       Token = False
       Last.Token = 3
    CASE Quote ' parse string in quotes
       CALL Parse.Quoted
       Quotes = True
    CASE "(" ' calculate opening parenthesis
       CALL Get.Token ' read next token value inside parenthesis
       IF Strng = ")" THEN
          Strng = "<empty closing token>"
          ERROR 92
       END IF
       IF Strng <> ")" THEN
	  DO ' calculate value
	     CALL Parse1(Temp#) ' recursively call parse entry
	  LOOP UNTIL Strng = ")" OR Token = False ' check closing parenthesis
       END IF
       IF Token = False THEN
          Strng = "<missing closing token>"
          ERROR 92
       END IF
       CALL Get.Token ' read next token after parenthesis
    CASE "["
       CALL Get.Token
       IF Strng = "]" THEN
          Strng = "<empty closing token>"
          ERROR 92
       END IF
       IF Strng <> "]" THEN
	  DO
	     CALL Parse1(Temp#) ' recursively call parse entry
	  LOOP UNTIL Strng = "]" OR Token = False ' check closing parenthesis
       END IF
       IF Token = False THEN
          Strng = "<missing closing token>"
          ERROR 92
       END IF
       CALL Get.Token ' read next token after parenthesis
    CASE "{"
       CALL Get.Token
       IF Strng = "}" THEN
          Strng = "<empty closing token>"
          ERROR 92
       END IF
       IF Strng <> "}" THEN
	  DO
	     CALL Parse1(Temp#) ' recursively call parse entry
	  LOOP UNTIL Strng = "}" OR Token = False ' check closing parenthesis
       END IF
       IF Token = False THEN
          Strng = "<missing closing token>"
          ERROR 92
       END IF
       CALL Get.Token ' read next token after parenthesis
    CASE ")", "]", "}" ' check token is unmatched parenthesis
       IF Allow.Extra <= False THEN
          Strng = "<extra closing token>"
          ERROR 92
       END IF
    END SELECT
 CASE 2 ' token is numeric value
    CALL Parse.Numeric(Temp#)
 CASE 3 ' token type is alphabetic
    SELECT CASE LEN(Strng) ' check token length
    CASE 1
       ' parse the token
       CALL Parse.Alphabetic1(Temp#)
    CASE 2
       SELECT CASE UCASE$(Strng)
       ' special tokens
       CASE "AS"
	  CALL Get.Token
	  EXIT SUB
       CASE "TO"
	  CALL Get.Token
	  CALL Parse1(Temp4#)
	  FinishFor = Temp4#
	  EXIT SUB
       END SELECT
       ' parse the token
       CALL Parse.Alphabetic2(Temp#)
    CASE ELSE
       SELECT CASE UCASE$(Strng)
       ' printing tokens
       CASE "SPC"
          IF Printing = 0 THEN
             ERROR 92
          END IF
          IF PrinterLF = -2 THEN
             ERROR 92
          END IF
          CALL Get.Token3
          CALL Get.Token
          CALL Parse1(Temp#)
          SELECT CASE PrinterLF
          CASE -1
             If Temp#<0# Then
                ERROR 161
             Else
                LPRINT SPACE$(Temp#);
             Endif
          CASE 1
             PRINT SPC(Temp#);
          END SELECT
          CALL Get.Token
          IF PrinterLF THEN
             CALL Get.Token
             CALL Parse1(Temp#)
          END IF
          EXIT SUB
       CASE "TAB"
          IF Printing = 0 THEN
             ERROR 92
          END IF
          IF PrinterLF = -2 THEN
             ERROR 92
          END IF
          CALL Get.Token3
          CALL Get.Token
          CALL Parse1(Temp#)
          SELECT CASE PrinterLF
          CASE -1
             LPRINT TAB(Temp#);
          CASE 1
             PRINT TAB(Temp#);
          END SELECT
          CALL Get.Token
          IF PrinterLF THEN
             CALL Get.Token
             CALL Parse1(Temp#)
          END IF
          EXIT SUB
       ' special tokens
       CASE "THEN"
          CALL Get.Token
          EXIT SUB
       CASE "STEP"
          CALL Get.Token
          CALL Parse1(Temp4#)
          StepTo = Temp4#
          EXIT SUB
       CASE "EXCEPT"
          CALL Get.Token
          CALL Parse1(Temp4#)
          ExceptStep = Temp4#
          ExceptStepIs = True
          EXIT SUB
       CASE "UNLESS"
          CALL Get.Token
          CALL Parse1(Temp4#)
          Unless.Branch = True
          Unless.Value = Temp4#
          EXIT SUB
       END SELECT
       ' parse the token
       CALL Parse.Alphabetic3(Temp#)
    END SELECT
    ' parse the last token
    ' after any alphabetic token
    ' except the special tokens above.
    CALL Get.Token
 END SELECT
END SUB

' parses data statements.
SUB Read.Data.Element (More.Data)
 More.Data = False
 VarX = DataLine
 Stored.Out2$ = Out2
 Stored.Token.Index = Token.Index
 DO
    Out2 = Program(VarX)
    Out2 = STRIM$(Out2)
    Out2 = UCASE$(Out2)
    IF LEFT$(Out2, 4) <> "DATA" THEN
       Var = DataLine
       Var2 = False
       DO
          IF Var >= Last.Line THEN
             EXIT DO
          END IF
          Var = Var + 1
          Strng2$ = Program(Var)
          Strng2$ = STRIM$(Strng2$)
          Strng2$ = UCASE$(Strng2$)
          IF LEFT$(Strng2$, 4) = "DATA" THEN
             DataLine = Var
             Var2 = True
             EXIT DO
          END IF
       LOOP
       IF Var2 = False THEN
          More.Data = True
          EXIT SUB
       END IF
       DataNumber = False
    END IF
    Out2 = Program(DataLine)
    Out2 = STRIM$(Out2)
    Out2 = MID$(Out2, 5)
    Out2 = XTRIM$(Out2, True)
    CALL Trim.Comment

    ' append trailing data seperator
    Out2 = Out2 + ","

    Data.Count = False
    Token.Index = 1
    DO
       Last.Token = False
       CALL Get.Token
       SELECT CASE Strng
       CASE ",", ";"
          DataValue = 0#
          Out3 = Nul
       CASE ELSE
          ' allow equations in DATA elements!?
          CALL Parse1(DataValue)

          ' next token should be data terminator
          SELECT CASE Strng
          CASE Quote
             ERROR 133
             EXIT SUB
          CASE ",", ";"
             Eat$ = Nul
          CASE ELSE
             ERROR 66
             EXIT SUB
          END SELECT
       END SELECT
       IF Data.Count = DataNumber THEN
	  DataNumber = DataNumber + 1
	  Out2 = Stored.Out2$
	  Token.Index = Stored.Token.Index
	  EXIT SUB
       END IF
       IF Token.Index > LEN(Out2) THEN
	  EXIT DO
       END IF
       Data.Count = Data.Count + 1
    LOOP
    VarX = VarX + 1
    DataNumber = False
 LOOP
END SUB

' determine operating system
SUB OS
 IF DOSbox = -2 THEN
    OperatingSystem = "DOSbox-X"
    EXIT SUB
 END IF
 IF DOSbox = -1 THEN
    OperatingSystem = "DOSbox"
    EXIT SUB
 END IF
 IF DOSbox = 1 THEN
    OperatingSystem = "MS-DOS"
    EXIT SUB
 END IF
 If Windows.Detected Then
    InregsX.AX=&H160A
    CALL InterruptX(&H2F,InregsX,OutregsX)
    Major=(OutregsX.BX AND &HFF00)/256
    Minor=(OutregsX.BX AND &HFF)
    If Major>=4 Then
       If Minor>10 Then
          OperatingSystem = "Windows ME"
       Else
          If Minor=10 Then
             OperatingSystem = "Windows 98"
          Else
             If Minor=3 Then
                OperatingSystem = "Windows 95B"
             Else
                OperatingSystem = "Windows 95"
             Endif
          Endif
       Endif
    Else
       If Major = 0 And Minor = 0 Then
          OperatingSystem = "Windows"
       Else
          OperatingSystem = "Windows v"+Ltrim$(Str$(Major))+"."+Ltrim$(Str$(Minor))
       Endif
    Endif
    Exit Sub
 Endif
 InregsX.AX=&H3001
 CALL InterruptX(&H21,InregsX,OutregsX)
 Major=(OutregsX.AX AND &HFF)
 Minor=(OutregsX.AX AND &HFF00)/256
 If Major=10 Then
    OperatingSystem = "OS/2 v1.0"
 Else
    If Major=20 Then
       If Minor=40 Then
          OperatingSystem = "OS/2 v4.0"
       Else
          If Minor=30 Then
             OperatingSystem = "OS/2 v3.0"
          Else
             OperatingSystem = "OS/2 v2.0"
          Endif
       Endif
    Else
       OperatingSystem = "DOS v"+Ltrim$(Str$(Major))+"."+Ltrim$(Str$(Minor))
    Endif
 Endif
END SUB

' routine to read error string data file
SUB Read.Config(File.Found)
 ' reset init variables
 Program.Resume = True
 Filename = ErrorList

 ' get filename
 Call Find.File(Config.Filename$,File.Found)

 ' reset array bounds
 Max.Errors = 0
 Array.Size = 7

 ' initialize error string array
 REDIM Errors(0 To 7) AS STRING * 64

 ' read in the data file
 IF File.Found THEN
    OPEN Config.Filename$ FOR INPUT AS #1
    DO
       ' check file length
       IF EOF(1) THEN
          EXIT DO
       END IF

       ' check array size
       IF Max.Errors = 255 THEN
          EXIT DO
       END IF

       ' increment array bounds
       Max.Errors = Max.Errors + 1
       IF Max.Errors = Array.Size THEN
          ' resize array
          Array.Size = Array.Size + 8
          REDIM PRESERVE Errors(0 To Array.Size) AS STRING * 64
       END IF

       ' read file line
       LINE INPUT #1, Error.String$

       ' store line
       Error.String$ = LTRIM$(Error.String$)
       Error.String$ = RTRIM$(Error.String$)
       IF LEN(Error.String$) THEN
          Errors(Max.Errors) = Error.String$
       ELSE
          Errors(Max.Errors) = "Error #" + MID$(STR$(Max.Errors), 2)
       END IF
    LOOP
    CLOSE
 END IF

 ' resize the error string array
 IF Max.Errors = 0 THEN
    REDIM Errors(1) AS STRING * 64
    Errors(1) = "Error #1"
 ELSE
    IF Max.Errors < 255 THEN
       REDIM PRESERVE Errors(Max.Errors) AS STRING * 64
    END IF
 END IF
 Program.Resume = False
END SUB

' parses filename and returns drive\path\filename.sic
Sub Concatenate(Program.File$)
 Program.File$ = STRIM$(Program.File$)
 Program.File$ = LCASE$(Program.File$)
 Program.Drive$ = Nul
 Program.Path$ = Nul
 If Mid$(Program.File$, 2, 1) = ":" Then
    Program.Drive$ = Left$(Program.File$, 2)
    Program.File$ = Mid$(Program.File$, 3)
 Endif
 For Var = Len(Program.File$) To 1 Step -1
    If Mid$(Program.File$, Var, 1) = "\" Then
       Program.Path$ = Left$(Program.File$, Var)
       Program.File$ = Mid$(Program.File$, Var + 1)
       Exit For
    Endif
 Next
 IF RIGHT$(Program.File$, 4) = ".sic" THEN
    Program.File$ = LEFT$(Program.File$, LEN(Program.File$) - 4)
 END IF
 Program.File$ = Program.Drive$ + Program.Path$ + Program.File$ + ".sic"
End Sub

' searches path and environment for filename
SUB Find.File(Find.Filename$,File.Found)
 DIM ASCIIZ1 AS STRING * 260
 DIM ASCIIZ2 AS STRING * 260
 File.Found = False
 ' find the data file
 Find.Filename$ = Filename
 IF DIR$(Filename) <> Nul THEN
    File.Found = True
    EXIT SUB
 END IF
 ' search environment data file
 File$ = ENVIRON$("SICCONFIG")
 IF LEN(File$) THEN
    If Right$(File$,1)=Quote Then
       If Left$(File$,1)=Quote Then
          File$=Mid$(File$,2)
          File$=Left$(File$,Len(File$)-1)
       Endif
    Endif
    File$ = RTRIM$(File$)
    File$ = LTRIM$(File$)
    IF RIGHT$(File$, 1) <> "\" THEN
       File$ = File$ + "\"
    END IF
    Find.Filename$ = File$ + Filename
    Gosub Ambiguate
    IF DIR$(Find.Filename$) <> Nul THEN
       File.Found = True
       EXIT SUB
    END IF
 END IF
 ' search path statement
 Path$ = ENVIRON$("PATH")
 DO
    ' parse path
    If Path$ = Nul Then
       Exit Do
    Endif
    Parse = INSTR(Path$, ";")
    IF Parse THEN
       File$ = LEFT$(Path$, Parse - 1)
       Path$ = MID$(Path$, Parse + 1)
    ELSE
       File$ = Path$
       Path$ = Nul
    END IF
    If Right$(File$,1)=Quote Then
       If Left$(File$,1)=Quote Then
          File$=Mid$(File$,2)
          File$=Left$(File$,Len(File$)-1)
       Endif
    Endif
    ' store filename
    File$ = RTRIM$(File$)
    File$ = LTRIM$(File$)
    IF LEN(File$) THEN
       IF RIGHT$(File$, 1) <> "\" THEN
          File$ = File$ + "\"
       END IF
       Find.Filename$ = File$ + Filename
       Gosub Ambiguate
       IF DIR$(Find.Filename$) <> Nul THEN
          File.Found = True
          EXIT SUB
       END IF
    END IF
 LOOP
 EXIT SUB

Ambiguate:
 ' ambiguate filename
 ASCIIZ1 = Find.Filename$ + CHR$(0)
 InregsX.AX = &H7160
 InregsX.CX = &H8001
 InregsX.DS = VARSEG(ASCIIZ1)
 InregsX.SI = VARPTR(ASCIIZ1)
 InregsX.ES = VARSEG(ASCIIZ2)
 InregsX.DI = VARPTR(ASCIIZ2)
 CALL InterruptX(&H21, InregsX, OutregsX)

 ' check carry flag error
 IF (OutregsX.Flags AND &H1) = &H0 THEN
    ' store windows 8.3 filename
    Find.Filename$ = ASCIIZ2
    Imbedded = INSTR(Find.Filename$, CHR$(0))
    IF Imbedded THEN
       Find.Filename$ = LEFT$(Find.Filename$, Imbedded - 1)
    END IF
 END IF
 RETURN
END SUB

SUB GetBits (Temp#)
 ' store directory search dta
 InregsX.AX = &H1A00
 InregsX.DS = VARSEG(ParseDTA)
 InregsX.DX = VARPTR(ParseDTA)
 CALL InterruptX(&H21, InregsX, OutregsX)
 ' find first filename
 ASCIIZ = Out3 + CHR$(0)
 InregsX.AX = &H4E00
 InregsX.CX = &H37
 InregsX.DS = VARSEG(ASCIIZ)
 InregsX.DX = VARPTR(ASCIIZ)
 CALL InterruptX(&H21, InregsX, OutregsX)
 ' check findfirst error
 IF (OutregsX.Flags AND &H1) = &H1 THEN
    Temp# = -1#
 END IF
 IF (OutregsX.Flags AND &H1) = &H0 THEN
    ' store file attributes
    Temp# = ASC(ParseDTA.FileAttr)
 END IF
 ' restore basic dta
 InregsX.AX = &H1A00
 InregsX.DS = BASIC.DTA.SEG
 InregsX.DX = BASIC.DTA.OFF
 CALL InterruptX(&H21, InregsX, OutregsX)
END SUB

SUB Capitalize (Var3$)
Var3$ = RTRIM$(LTRIM$(Var3$))
IF Var3$ = Nul THEN
   EXIT SUB
END IF
MID$(Var3$, 1, 1) = UCASE$(MID$(Var3$, 1, 1))
Var = INSTR(Var3$, " ")
IF Var < LEN(Var3$) THEN
   DO WHILE Var
      MID$(Var3$, Var + 1, 1) = UCASE$(MID$(Var3$, Var + 1, 1))
      Var = INSTR(Var + 1, Var3$, " ")
   LOOP
END IF
END SUB

' calculate byte suffix
SUB Suffix(Var#, Var3$)

 REM B  (Byte) = 00x - 0FFx (hexidecimal zero-based)
 REM KB (Kilobyte) = 1024 B
 REM MB (Megabyte) = 1024 KB (1 MB B)
 REM GB (Gigabyte) = 1024 MB
 REM TB (Terabyte) = 1024 GB (1 MB MB)
 REM PB (Petabyte) = 1024 TB
 REM EB (Exabyte) = 1024 PB (1 MB TB)
 REM ZB (Zettabyte) = 1024 EB
 REM YB (Yottabyte) = 1024 ZB (1 MB EB)

 ' check double
 VarX# = Var#
 s$ = STR$(VarX#)
 IF INSTR(s$, "D") THEN
    Var3$ = s$
    EXIT SUB
 END IF

 ' get sign
 IF VarX# < 0# THEN
    Sign = -1
    VarX# = ABS(VarX#)
 END IF

 ' calculate bytes
 TempA = False
 DO
    IF VarX# >= 1024 THEN
       VarX# = VarX# / 1024
       TempA = TempA + 1
       IF TempA = 8 THEN
	  EXIT DO
       END IF
    ELSE
       EXIT DO
    END IF
 LOOP

 ' calculate byte string
 Var3$ = FORMAT$(VarX#, "#,##0.0;;")

 ' calculate byte suffix
 Var$ = Nul
 IF TempA > 0 THEN
    Var$ = MID$("KMGTPEZY", TempA, 1)
 END IF
 Var3$ = Var3$ + " " + Var$ + "B"

 ' calculate byte sign
 IF Sign THEN
    Var3$ = "-" + Var3$
 END IF
END SUB

' trim trailing comment/underscore
SUB Trim.Comment
 IF LEN(Out2) THEN
    Start.Char = 1
    DO
       Quote.Start = False
       FOR Temp = Start.Char TO LEN(Out2)
          IF MID$(Out2, Temp, 1) = CHR$(34) THEN
             Quote.Start = Temp
             EXIT FOR
          END IF
       NEXT
       IF Quote.Start = False THEN
          EXIT DO
       END IF
       Quote.Stop = False
       FOR Temp2 = Quote.Start + 1 TO LEN(Out2)
          IF MID$(Out2, Temp2, 1) = CHR$(34) THEN
             Quote.Stop = Temp2
             EXIT FOR
          END IF
       NEXT
       IF Quote.Stop = False THEN
          EXIT DO
       END IF
       Start.Char = Quote.Stop + 1
    LOOP
    FOR Temp = Start.Char TO LEN(Out2)
       IF MID$(Out2, Temp, 1) = "'" THEN
          Out2 = LEFT$(Out2, Temp - 1)
          EXIT FOR
       END IF
    NEXT
    Out2 = STRIM$(Out2)
 END IF

 ' trim continuation character
 DO
    V$ = RIGHT$(Out2, 1)
    IF V$ = CHR$(9) OR V$ = CHR$(32) OR V$ = "_" THEN
       Out2 = LEFT$(Out2, LEN(Out2) - 1)
    ELSE
       EXIT DO
    END IF
 LOOP
END SUB

' special print function requires:
'    Print Using (<x>,"x"), (<x>,"x"), ...
SUB Print.Using
AllowExtra = True
Printing = True
Last.Token = False
Out3 = Nul
Out4 = Nul
Temp# = False
Token.Index = 1
Out2 = MID$(Out2, 12)
Out2 = STRIM$(Out2)
Out2 = XTRIM$(Out2, True)

IF RIGHT$(Out2, 1) = ";" OR RIGHT$(Out2, 1) = "," THEN
   LineFeed = True
ELSE
   LineFeed = False
END IF

PrinterLF = 1
DO
   Last.Token = False
   CALL Get.Token
   IF Strng <> "(" THEN
      Strng = "<missing left token>"
      ERROR 92
      EXIT SUB
   END IF
   CALL Get.Token
   CALL Parse1(Temp3#)
   IF ErrorValue THEN
      ErrorValue = 0
      EXIT SUB
   END IF
   Number# = Temp3#
   CALL Get.Token
   CALL Parse1(Temp3#)
   IF ErrorValue THEN
      ErrorValue = 0
      EXIT SUB
   END IF
   Strng = MID$(Out2, Token.Index, 1)
   Token.Index = Token.Index + 1
   SELECT CASE Strng
      CASE ","
         SELECT CASE Last.Token
            CASE -1
               Strng = "<string error>"
               ERROR 92
            CASE 0
               PRINT USING Out3; Number#;
               PRINT , "";
            CASE ELSE
               PRINT "",
         END SELECT
      CASE ";"
         SELECT CASE Last.Token
            CASE -1
               Strng = "<string error>"
               ERROR 92
            CASE 0
               PRINT USING Out3; Number#;
            CASE ELSE
               PRINT "";
         END SELECT
      CASE ELSE
         IF LEN(Strng) THEN
            Strng = "<extra token>"
            ERROR 92
         END IF
         SELECT CASE Last.Token
            CASE -1
               Strng = "<string error>"
               ERROR 92
            CASE 0
               PRINT USING Out3; Number#;
            CASE ELSE
               PRINT "";
         END SELECT
         EXIT DO
   END SELECT
   IF Token.Index > LEN(Out2) THEN
      EXIT DO
   END IF
LOOP
IF RIGHT$(Out2, 1) = ";" OR RIGHT$(Out2, 1) = "," THEN
   Out2 = LEFT$(Out2, LEN(Out2) - 1)
END IF
IF RIGHT$(Out2, 1) <> ")" THEN
   Strng = "<missing right token>"
   ERROR 92
   EXIT SUB
END IF
IF LineFeed = False THEN
   PRINT
END IF
PrinterLF = False
Printing = False
END SUB

' special lprint function requires:
'    Lprint Using (<x>,"x"), (<x>,"x"), ...
SUB Lprint.Using
AllowExtra = True
Printing = True
Last.Token = False
Out3 = Nul
Out4 = Nul
Temp# = False
Token.Index = 1
Out2 = MID$(Out2, 13)
Out2 = STRIM$(Out2)
Out2 = XTRIM$(Out2, True)

IF RIGHT$(Out2, 1) = ";" OR RIGHT$(Out2, 1) = "," THEN
   LineFeed = True
ELSE
   LineFeed = False
END IF

PrinterLF = True
DO
   Last.Token = False
   CALL Get.Token
   IF Strng <> "(" THEN
      Strng = "<missing left token>"
      ERROR 92
      EXIT SUB
   END IF
   CALL Get.Token
   CALL Parse1(Temp3#)
   IF ErrorValue THEN
      ErrorValue = 0
      EXIT SUB
   END IF
   Number# = Temp3#
   CALL Get.Token
   CALL Parse1(Temp3#)
   IF ErrorValue THEN
      ErrorValue = 0
      EXIT SUB
   END IF
   Strng = MID$(Out2, Token.Index, 1)
   Token.Index = Token.Index + 1
   SELECT CASE Strng
      CASE ","
         SELECT CASE Last.Token
            CASE -1
               Strng = "<string error>"
               ERROR 92
            CASE 0
               LPRINT USING Out3; Number#;
               LPRINT , "";
            CASE ELSE
               LPRINT "",
         END SELECT
      CASE ";"
         SELECT CASE Last.Token
            CASE -1
               Strng = "<string error>"
               ERROR 92
            CASE 0
               LPRINT USING Out3; Number#;
            CASE ELSE
               LPRINT "";
         END SELECT
      CASE ELSE
         IF LEN(Strng) THEN
            Strng = "<extra token>"
            ERROR 92
         END IF
         SELECT CASE Last.Token
            CASE -1
               Strng = "<string error>"
               ERROR 92
            CASE 0
               LPRINT USING Out3; Number#;
            CASE ELSE
               LPRINT "";
         END SELECT
         EXIT DO
   END SELECT
   IF Token.Index > LEN(Out2) THEN
      EXIT DO
   END IF
LOOP
IF RIGHT$(Out2, 1) = ";" OR RIGHT$(Out2, 1) = "," THEN
   Out2 = LEFT$(Out2, LEN(Out2) - 1)
END IF
IF RIGHT$(Out2, 1) <> ")" THEN
   Strng = "<missing right token>"
   ERROR 92
   EXIT SUB
END IF
IF LineFeed = False THEN
   LPRINT
END IF
PrinterLF = False
Printing = False
END SUB

REM Plays .wav files for blind or sight impaired people.

REM Dmaplay.bas code was adapted from Dma.zip written by Mike Huff (1996).
REM Which was modified by Martin Rampersad.
REM And was rewritten into Playwav.bas,
REM Program downloaded from http://www.ocf.berkeley.edu/~horie

SUB Playwav(Tmp1,Tmp1$)
 On Local Error Goto Play.Error

 ' select .wav file
 If Tmp1>0 Then
 Select Case Tmp1
 Case 1
    Tmp1$="Laser.wav"
 Case 2
    Tmp1$="Ringin.wav"
 Case 3
    Tmp1$="Carrier.wav"
 Case 4
    Tmp1$="Boing.wav"
 Case 5
    Tmp1$="Bang.wav"
 Case 6
    Tmp1$="Connect.wav"
 Case 7
    Tmp1$="Complete.wav"
 Case 8
    Tmp1$="Gunshot.wav"
 Case 9
    Tmp1$="Ricochet.wav"
 Case 10 ' a
    Tmp1$="Whoosh.wav"
 Case 11 ' b
    Tmp1$="Glass.wav"
 Case 12 ' c
    Tmp1$="Cashreg.wav"
 Case Else
    Error 92
    Exit Sub
 End Select
 Endif

 ' locate file
 IF Tmp1$ = Nul THEN
    EXIT SUB
 END IF
 Tmp2$ = Tmp1$
 IF DIR$(Tmp2$) = Nul THEN
    EXIT SUB
 END IF

 ' Parse BLASTER environment variable
 Call GetBLASTER
 If BasePort% = 0% Then
    Error 92
    Exit Sub
 Endif

 ' reopen input file
 X = FREEFILE
 IF X = 0 THEN
    EXIT SUB
 END IF
 OPEN Tmp2$ FOR BINARY AS #X

 ' create buffer for file.
 REDIM WavBuffer(1 TO 1) AS STRING * PlayBuffer

 ' turn on speaker and adjust volume.
 Call AdjustVolume(SpeakerVolume)

 ' get buffer from file skipping header.
 GET #X, 44, WavBuffer(1)

 ' store memory address of sound buffer.
 Segment& = VARSEG(WavBuffer(1))
 Offset& = VARPTR(WavBuffer(1))

 ' store length of sound file minus header.
 Length& = LOF(X) - 44

 ' Adjust length if needed to 32k
 IF Length& > 32767 THEN Length& = 32767

 ' call the sound buffer player.
 CALL DMAPlay(Segment&, Offset&, Length&)

 Close #X
 Erase WavBuffer
 EXIT SUB
Play.Resume:
 Exit Sub
Play.Error:
 Resume Play.Resume
END SUB

' plays the contents of the buffer.
SUB DMAPlay(Segment&, Offset&, Length&)
 Freq& = 10000
 Length& = Length& - 1
 Page% = 0
 MemLoc& = Segment& * 16 + Offset&
 SELECT CASE Channel%
 CASE 0
    PgPort% = &H87
    AddPort% = &H0
    LenPort% = &H1
    ModeReg% = &H48
 CASE 1
    PgPort% = &H83
    AddPort% = &H2
    LenPort% = &H3
    ModeReg% = &H49
 CASE 2
    PgPort% = &H81
    AddPort% = &H4
    LenPort% = &H5
    ModeReg% = &H4A
 CASE 3
    PgPort% = &H82
    AddPort% = &H6
    LenPort% = &H7
    ModeReg% = &H4B
 CASE ELSE
    EXIT SUB
 END SELECT
 OUT &HA, &H4 + Channel%
 OUT &HC, &H0
 OUT &HB, ModeReg%
 OUT AddPort%, MemLoc& AND &HFF
 OUT AddPort%,(MemLoc& AND &HFFFF&) \ &H100
 IF MemLoc& AND 65536 THEN
    Page% = Page% + 1
 END IF
 IF MemLoc& AND 131072 THEN
    Page% = Page% + 2
 END IF
 IF MemLoc& AND 262144 THEN
    Page% = Page% + 4
 END IF
 IF MemLoc& AND 524288 THEN
    Page% = Page% + 8
 END IF
 OUT PgPort%, Page%
 OUT LenPort%, Length& AND &HFF
 OUT LenPort%, (Length& AND &HFFFF&) \ &H100
 OUT &HA, Channel%

 TimeConst% = 256 - 1000000 \ Freq&
 V% = &H40
 Call WriteDSP(V%)

 V% = TimeConst%
 Call WriteDSP(V%)

 V% = &H14
 Call WriteDSP(V%)

 V% = Cint(Length& AND &HFF)
 Call WriteDSP(V%)

 V% = Cint((Length& AND &HFFFF&) \ &H100)
 Call WriteDSP(V%)
END SUB

' parse the BLASTER environment string and return settings.
SUB GetBlaster
 REM SET BLASTER=A220 I5 D1 H5 P330 T3 V9
 Var$ = Environ$("BLASTER")
 IF Var$ = Nul THEN ' default values
    BasePort% = &H220
    Channel% = &H1
    SpeakerVolume = 13
    EXIT SUB
 END IF
 Var% = INSTR(Var$, "A") ' base IO port
 If Var% Then ' A220
    BasePort% = VAL("&H" + MID$(Var$, Var% + 1, 3))
 Endif
 Var% = INSTR(Var$, "D") ' 8-bit DMA channel
 If Var% Then ' D1
    Channel% = VAL(MID$(Var$, Var% + 1, 1))
 Endif
 SpeakerVolume=13
 Var% = INSTR(Var$, "V") ' speaker volume
 If Var% Then ' V1
    SpeakerVolume = VAL(MID$(Var$, Var% + 1))
 Endif
 Var$ = Environ$("BLASTERVOLUME")
 IF Len(Var$) THEN ' default volume
    SpeakerVolume=Int(Val(Var$))
 Endif
END SUB

' turn on speaker and adjust volume.
SUB AdjustVolume(Loudness%)
 ' Turn on speaker.
 V% = &HD1
 Call WriteDSP(V%)
 ' Adjust the volume.
 V% = Loudness% + Loudness% * 16 ' right/left
 OUT BasePort% + 4, &H22
 OUT BasePort% + 5, V% AND &HFF
END SUB

' writes a byte to the DSP (digital signal processor)
SUB WriteDSP(byte2%)
 DO: LOOP WHILE INP(BasePort% + 12) AND &H80
 OUT BasePort% + 12, byte2%
END SUB

SUB Lock.File ' lock #
Out2 = MID$(Out2, 7)
Out2 = STRIM$(Out2)
Token.Index = 1
CALL Get.Token
CALL Parse1(Temp4#)
File.Num = CINT(Temp4#)
IF File.Num <= 0 OR File.Num > MaxFiles THEN
   ERROR 126
   EXIT SUB
END IF
If FileTraps(File.Num) Then
   ControlBreak = -2
   Exit Sub
End If
IF Strng = "," Or Strng = ";" THEN
   CALL Get.Token
   CALL Parse1(Temp4#)
   Filerec& = CLNG(Temp4#)
   IF Strng = "," Or Strng = ";" Or Strng = "TO" THEN
      CALL Get.Token
      CALL Parse1(Temp4#)
      Filerec2& = CLNG(Temp4#)
      LOCK File.Num, Filerec& TO Filerec2&
      For Z = 1 To RecordCount
         If FileRecords(Z) > 0& Then
            If FileRecords(Z) = Filerec& Then
               RecordNumber = Filerec&
               ControlBreak = -3
               Exit Sub
            End If
         End If
      Next
      For Z = 1 To RecordCount
         If FileRecords(Z) > 0& Then
            If FileRecords(Z) = Filerec2& Then
               RecordNumber = Filerec2&
               ControlBreak = -3
               Exit Sub
            End If
        End If
      Next
   ELSE
      LOCK File.Num, Filerec&
      For Z = 1 To RecordCount
         If FileRecords(Z) > 0& Then
            If FileRecords(Z) = Filerec& Then
               RecordNumber = Filerec&
               ControlBreak = -3
               Exit Sub
            End If
         End If
      Next
   END IF
   EXIT SUB
END IF
LOCK File.Num
END SUB

SUB Unlock.File ' unlock #
Out2 = MID$(Out2, 9)
Out2 = STRIM$(Out2)
Token.Index = 1
CALL Get.Token
CALL Parse1(Temp4#)
File.Num = CINT(Temp4#)
IF File.Num <= 0 OR File.Num > MaxFiles THEN
   ERROR 126
   EXIT SUB
END IF
If FileTraps(File.Num) Then
   ControlBreak = -2
   Exit Sub
End If
IF Strng = "," Or Strng = ";" THEN
   CALL Get.Token
   CALL Parse1(Temp4#)
   Filerec& = CLNG(Temp4#)
   IF Strng = "," Or Strng = ";" Or Strng = "TO" THEN
      CALL Get.Token
      CALL Parse1(Temp4#)
      Filerec2& = CLNG(Temp4#)
      UNLOCK File.Num, Filerec& TO Filerec2&
      For Z = 1 To RecordCount
         If FileRecords(Z) > 0& Then
            If FileRecords(Z) = Filerec& Then
               RecordNumber = Filerec&
               ControlBreak = -3
               Exit Sub
            End If
         End If
      Next
      For Z = 1 To RecordCount
         If FileRecords(Z) > 0& Then
            If FileRecords(Z) = Filerec2& Then
               RecordNumber = Filerec2&
               ControlBreak = -3
               Exit Sub
            End If
         End If
      Next
   ELSE
      UNLOCK File.Num, Filerec&
      For Z = 1 To RecordCount
         If FileRecords(Z) > 0& Then
            If FileRecords(Z) = Filerec& Then
               RecordNumber = Filerec&
               ControlBreak = -3
               Exit Sub
            End If
         End If
      Next
   END IF
   EXIT SUB
END IF
UNLOCK File.Num
END SUB

SUB Sleep.Second
 Out2 = MID$(Out2, 6)
 Out2 = STRIM$(Out2)
 IF LEN(Out2) = False THEN
    Temp3# = 1#
 ELSE
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp3#)
 END IF
 SLEEP CSNG(Temp3#)
END SUB

SUB Pause.Second
 Out2 = MID$(Out2, 6)
 Out2 = STRIM$(Out2)
 IF LEN(Out2) = False THEN
    Temp3# = 1#
 ELSE
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp3#)
 END IF
 Pause.Time! = CSNG(Temp3#)
 Time.Now! = TIMER
 DO
    ' calculate time elapsed
    Elapsed.Time! = TIMER - Time.Now!
    ' adjust for midnight
    IF Elapsed.Time! < 0! THEN
       Elapsed.Time! = Elapsed.Time! + 86400!
    END IF
    ' compare time elapsed
    IF Elapsed.Time! > Pause.Time! THEN
       EXIT DO
    END IF
 LOOP
END SUB

SUB Output.Port
 Out2 = MID$(Out2, 4)
 Out2 = STRIM$(Out2)
 Token.Index = 1
 CALL Get.Token
 CALL Parse1(Temp4#)
 Port.Address = CINT(Temp4#)
 IF Strng = "," THEN
    CALL Get.Token
    CALL Parse1(Temp4#)
    Port.Byte = CINT(Temp4#)
    OUT Port.Address, Port.Byte
    EXIT SUB
 END IF
 ERROR 121
END SUB

SUB Wait.Port
 Allow.Extra = True
 Out2 = MID$(Out2, 5)
 Out2 = STRIM$(Out2)
 IF LEN(Out2) THEN
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    Port.Address = CINT(Temp4#)
    IF Strng = "," THEN
       CALL Get.Token
       CALL Parse1(Temp4#)
       And.Value = CINT(Temp4#)
       Xor.Value = False
       IF Strng = "," THEN
	  CALL Get.Token
	  CALL Parse1(Temp4#)
	  Xor.Value = CINT(Temp4#)
       END IF
       WAIT Port.Address, And.Value, Xor.Value
       EXIT SUB
    END IF
 END IF
 ERROR 122
END SUB

SUB Int86.Function
 Out2 = MID$(Out2, 6)
 Out2 = STRIM$(Out2)
 Token.Index = 1
 CALL Get.Token3
 CALL Get.Token
 CALL Parse1(Temp4#)
 CALL Get.Token4
 Int86.Value = CINT(Temp4#)
 IF Int86.Value >= 0 AND Int86.Value <= 255 THEN
    InregsX.AX = INT(VAL("&H" + HEX$(AX)))
    InregsX.BX = INT(VAL("&H" + HEX$(BX)))
    InregsX.CX = INT(VAL("&H" + HEX$(CX)))
    InregsX.DX = INT(VAL("&H" + HEX$(DX)))
    InregsX.BP = INT(VAL("&H" + HEX$(BP)))
    InregsX.SI = INT(VAL("&H" + HEX$(SI)))
    InregsX.DI = INT(VAL("&H" + HEX$(DI)))
    InregsX.Flags = INT(VAL("&H" + HEX$(FL)))
    InregsX.DS = INT(VAL("&H" + HEX$(DS)))
    InregsX.ES = INT(VAL("&H" + HEX$(ES)))
    CALL InterruptX(Int86.Value, InregsX, OutregsX)
    IF OutregsX.AX < False THEN
       AX = CDBL(OutregsX.AX + 65536)
    ELSE
       AX = CDBL(OutregsX.AX)
    END IF
    IF OutregsX.BX < False THEN
       BX = CDBL(OutregsX.BX + 65536)
    ELSE
       BX = CDBL(OutregsX.BX)
    END IF
    IF OutregsX.CX < False THEN
       CX = CDBL(OutregsX.CX + 65536)
    ELSE
       CX = CDBL(OutregsX.CX)
    END IF
    IF OutregsX.DX < False THEN
       DX = CDBL(OutregsX.DX + 65536)
    ELSE
       DX = CDBL(OutregsX.DX)
    END IF
    IF OutregsX.BP < False THEN
       BP = CDBL(OutregsX.BP + 65536)
    ELSE
       BP = CDBL(OutregsX.BP)
    END IF
    IF OutregsX.SI < False THEN
       SI = CDBL(OutregsX.SI + 65536)
    ELSE
       SI = CDBL(OutregsX.SI)
    END IF
    IF OutregsX.DI < False THEN
       DI = CDBL(OutregsX.DI + 65536)
    ELSE
       DI = CDBL(OutregsX.DI)
    END IF
    IF OutregsX.Flags < False THEN
       FL = CDBL(OutregsX.Flags + 65536)
    ELSE
       FL = CDBL(OutregsX.Flags)
    END IF
    IF OutregsX.DS < False THEN
       DS = CDBL(OutregsX.DS + 65536)
    ELSE
       DS = CDBL(OutregsX.DS)
    END IF
    IF OutregsX.ES < False THEN
       ES = CDBL(OutregsX.ES + 65536)
    ELSE
       ES = CDBL(OutregsX.ES)
    END IF
 ELSE
    ERROR 158
 END IF
END SUB

SUB Defseg.Function
 Out2 = MID$(Out2, 7)
 Out2 = STRIM$(Out2)
 IF LEN(Out2) = False THEN
    DEF SEG ' restore segment
    InDEFSEG = False ' reset segment flag
    EXIT SUB
 END IF
 Token.Index = 1
 CALL Get.Token3
 CALL Get.Token
 CALL Parse1(Temp4#)
 CALL Get.Token4
 IF Temp4#>=0# AND Temp4#<=65535# THEN
    DEF SEG = Temp4# ' set segment
    InDEFSEG = True ' set segment flag
    DEFSEGvalue = Temp4# ' store segment value
    EXIT SUB
 END IF
 ERROR 125
END SUB

SUB Absolute.Function
 Out2 = MID$(Out2, 9)
 Out2 = STRIM$(Out2)
 IF LEN(Out2) THEN
    Token.Index = 1
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp4#)
    CALL Get.Token4
    CALL Absolute(CINT(Temp4#))
    EXIT SUB
 END IF
 ERROR 123
END SUB

SUB Poke.Value
 Out2 = MID$(Out2, 5)
 Out2 = STRIM$(Out2)
 Token.Index = 1
 CALL Get.Token
 CALL Parse1(Temp4#)
 Poke.Address = CINT(Temp4#)
 IF Strng = "," THEN
    CALL Get.Token
    CALL Parse1(Temp4#)
    Poke.Byte = CINT(Temp4#)
    POKE Poke.Address, Poke.Byte
    EXIT SUB
 END IF
 ERROR 124
END SUB

SUB Seed.Random
 Out2 = MID$(Out2, 10)
 Out2 = STRIM$(Out2)
 Token.Index = 1
 CALL Get.Token
 CALL Parse1(Temp3#)
 RANDOMIZE CLNG(Temp3#)
END SUB

 ' def fn(x)=value
SUB Define.Function
 Out2 = MID$(Out2, 7)
 Out2 = STRIM$(Out2)
 Token.Index = 1
 CALL Get.Token3
 CALL Get.Token
 CALL Parse1(Temp4#)
 CALL Get.Token4
 Func% = CINT(Temp4#)
 IF Func% >= 1 AND Func% <= Max.Functions THEN
    Out2 = MID$(Out2, Token.Index)
    Out2 = LTRIM$(Out2)
    IF LEFT$(Out2, 1) = "=" THEN
       Out2 = MID$(Out2, 2)
       Definitions(Func%) = Out2
       EXIT SUB
    END IF
 END IF
 ERROR 144
END SUB

SUB Swap.Data
 Temp1$ = MID$(Out2, 5)
 Temp1$ = STRIM$(Temp1$)
 Temp2$ = UCASE$(LEFT$(Temp1$, 1))
 IF Temp2$ >= "A" AND Temp2$ <= "Z" THEN
    Variable1 = ASC(Temp2$) - 64
    Temp1$ = MID$(Temp1$, 2)
    Temp1$ = STRIM$(Temp1$)
    IF LEFT$(Temp1$, 1) = "," THEN
       Temp1$ = MID$(Temp1$, 2)
       Temp1$ = STRIM$(Temp1$)
       Temp2$ = UCASE$(LEFT$(Temp1$, 1))
       IF Temp2$ >= "A" AND Temp2$ <= "Z" THEN
	  Variable2 = ASC(Temp2$) - 64
	  Temp1$ = MID$(Temp1$, 2)
	  Temp1$ = STRIM$(Temp1$)
	  IF Temp1$ = Nul THEN
	     SWAP Variables(Variable1), Variables(Variable2)
             EXIT SUB
	  ELSE
	     IF LEFT$(Temp1$, 1) = "(" THEN
		Out2 = MID$(Temp1$, 2)
		Out2 = STRIM$(Out2)
		Last.Token = False
		Token.Index = 1
		CALL Get.Token
		CALL Parse1(Temp3#)
		Element = CINT(Temp3#)
                IF Element > False AND Element <= Max.Arrays THEN
                   SWAP Variables(Variable1), Arrays(Variable2, Element)
                   EXIT SUB
                END IF
	     END IF
	  END IF
       END IF
    ELSE
       IF LEFT$(Temp1$, 1) = "(" THEN
	  Out2 = MID$(Temp1$, 2)
	  Out2 = STRIM$(Out2)
	  Last.Token = False
	  Token.Index = 1
	  CALL Get.Token
	  CALL Parse1(Temp3#)
	  Element1 = CINT(Temp3#)
	  Temp1$ = MID$(Out2, Token.Index)
	  Temp1$ = STRIM$(Temp1$)
	  IF LEFT$(Temp1$, 1) = "," THEN
	     Out2 = MID$(Temp1$, 2)
	     Out2 = UCASE$(Out2)
	     Temp1$ = MID$(Temp1$, 2)
	     Temp1$ = STRIM$(Temp1$)
	     Temp2$ = UCASE$(LEFT$(Temp1$, 1))
	     IF Temp2$ >= "A" AND Temp2$ <= "Z" THEN
		Variable2 = ASC(Temp2$) - 64
		Temp1$ = MID$(Temp1$, 2)
		Temp1$ = STRIM$(Temp1$)
		IF Temp1$ = Nul THEN
                   IF Element1 > False AND Element1 <= Max.Arrays THEN
                      SWAP Arrays(Variable1, Element1), Variables(Variable2)
                      EXIT SUB
                   END IF
		ELSE
		   IF LEFT$(Temp1$, 1) = "(" THEN
		      Out2 = MID$(Temp1$, 2)
		      Out2 = STRIM$(Out2)
		      Last.Token = False
		      Token.Index = 1
		      CALL Get.Token
		      CALL Parse1(Temp3#)
		      Element2 = CINT(Temp3#)
                      IF Element1 > False AND Element1 <= Max.Arrays THEN
                         IF Element2 > False AND Element2 <= Max.Arrays THEN
                            SWAP Arrays(Variable1, Element1), Arrays(Variable2, Element2)
                            EXIT SUB
                         END IF
                      END IF
		   END IF
		END IF
	     END IF
	  END IF
       ELSE
	  IF LEFT$(Temp1$, 1) = "$" THEN
	     Temp1$ = MID$(Temp1$, 2)
	     Temp1$ = STRIM$(Temp1$)
	     IF LEFT$(Temp1$, 1) = "," THEN
		Temp1$ = MID$(Temp1$, 2)
		Temp1$ = STRIM$(Temp1$)
		Temp2$ = UCASE$(LEFT$(Temp1$, 1))
		IF Temp2$ >= "A" AND Temp2$ <= "Z" THEN
		   Variable2 = ASC(Temp2$) - 64
		   Temp1$ = MID$(Temp1$, 2)
		   Temp1$ = STRIM$(Temp1$)
		   IF Temp1$ = "$" THEN
		      SWAP Strngs(Variable1), Strngs(Variable2)
                      EXIT SUB
		   END IF
		END IF
	     END IF
	  END IF
       END IF
    END IF
 END IF
 ERROR 110
END SUB

